--[[**
 * @Name: Function_bottom.lua
 * @Date: 2022-02-06 10:35:16
 * @Description: No special instructions
 *
**]]

-- load the "import" module,
-- which is use to import Java class and lua module
require "import"

-- Android base class library
-- if you don't need these, please remove them
import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
import "android.graphics.Color"
-- Inflate the layout for this page
-- activity.setContentView(loadlayout(layout))

-- this page using the provided parameters.
-- args=...
local uiManager=this.uiManager
local colors=uiManager.getColors()
colorPrimary=colors.colorPrimary--主色
colorAccent=colors.colorAccent--强调
colorTextPrimary=colors.textColorPrimary--主文本色
textColorSecondary=colors.textColorSecondary
colorBackground=colors.windowBackground--窗体背景色
import "android.content.res.ColorStateList"
colorRipple=ColorStateList.valueOf(0x44444444)


package.path=package.path..";"..activity.loader.projectDir.toString().."/libs/?.lua";

local function 波纹(id,颜色)
  import "android.content.res.ColorStateList"
  local attrsArray = {android.R.attr.selectableItemBackgroundBorderless}
  local typedArray =activity.obtainStyledAttributes(attrsArray)
  ripple=typedArray.getResourceId(0,0)
  Pretend=activity.Resources.getDrawable(ripple)
  Pretend.setColor(ColorStateList(int[0].class{int{}},int{颜色}))
  id.setBackground(Pretend.setColor(ColorStateList(int[0].class{int{}},int{颜色})))
end
-- TODO :
local function Input_field(a)
  import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
  import "android.content.res.ColorStateList"
  local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
  local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
  local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"
  local view_table=
  {LinearLayout,
    layout_width="match",
    layout_height="match",
    orientation=1,
    {TextInputLayout,
      id="input_layout",
      layout_height="wrap",
      layout_marginLeft="20dp",
      layout_marginRight="20dp",
      prefixText="* ",
      prefixTextColor=ColorStateList.valueOf(0xffff0000),
      --suffixText="后缀文本",
      --error="错误提示",
      layout_width="match",
      hint="请输入"..a,--设置输入框提示文本
      {TextInputEditText,
        id="edit_text",
        singleLine=true;--设置单行输入，禁止换行
        layout_height="wrap",
        layout_width="match",
      },
    },
    {TextInputLayout,
      --id="input_layout",
      layout_height="wrap",
      layout_marginLeft="20dp",
      layout_marginRight="20dp",
      --suffixText="后缀文本",
      --error="错误提示",
      layout_width="match",
      hint="请输入名称",--设置输入框提示文本
      {TextInputEditText,
        id="edit_text2",
        singleLine=true;--设置单行输入，禁止换行
        layout_height="wrap",
        layout_width="match",
      },
    },
  }

  local dialog=MaterialAlertDialogBuilder(activity)
  .setTitle(a.." 超连接")
  .setView(loadlayout(view_table))
  .setPositiveButton("确定",nil)
  .setNegativeButton("取消",nil)
  .show()

  dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
  dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
  dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
  task(100,function()
    local Context = luajava.bindClass "android.content.Context"
    import "android.view.inputmethod.InputMethodManager"
    edit_text.getContext().getSystemService(Context.INPUT_METHOD_SERVICE).toggleSoftInput(0,InputMethodManager.HIDE_NOT_ALWAYS)
    edit_text.requestFocus()
  end)
  dialog.getButton(AlertDialog.BUTTON1).onClick=function()
    local text=edit_text.text
    if text=="" then
      input_layout.setError(a.."不可为空")
     else
      local text2=edit_text2.text
      if text2=="" then
        text2=text
      end
      if a== "URL" then
        加载Js([[
          insertText(document.getElementById('needmessage'),"[url=]]..text..']'..text2..[[[/url]\n");
        ]])
       else
        加载Js([[
          insertText(document.getElementById('needmessage'),"[email=]]..text..']'..text2..[[[/email]\n");
        ]])
      end
      dialog.hide()
    end
  end
  edit_text.addTextChangedListener{
    onTextChanged=function()
      --事件
      if edit_text.text=="" then
        input_layout.setError(a.."不可为空")
       else
        input_layout.setError(null)
      end
    end
  }
end
function copy(text)
  activity.getSystemService("clipboard").text=text
  print("已复制连接")
end

local allowSuffixes = {"jpeg","jpg","png","gif","tif","bmp","ico","psd","webp"}
local maxSize = 6291456

--获取文件后缀名
function getFileExtension(file)
  local String = luajava.bindClass "java.lang.String"
  local name = String(file.getName())
  return name.substring(name.lastIndexOf(".")+1)
end
function indexOf(value,tbl)
  for k,v in pairs(tbl) do
    if v == value then
      return true;
    end
  end
  return false;
end
local function Http_upload(fileSrc,zhacai)
  import "okhttp3.*"
  print("上传中,请稍后")
  if fileSrc then
    local File = luajava.bindClass "java.io.File"
    local path=File(fileSrc)
    if not indexOf(getFileExtension(path),allowSuffixes) then
      print("不支持的文件格式",path.getName())
      return
    end
    if path.length() > maxSize then
      print("图片",path.getName(),"超出大小限制")
      return
    end
    Http.get("https://img.legado.cn/",function(code,content,cookie,header)
      if code==200 then
        local x_csrf_token = content:match('csrf%-token" content="(.-)">')
        import "java.net.URLEncoder"

        local requestBody = MultipartBody.Builder()
        .setType(MultipartBody.FORM)
        .addFormDataPart("file",path.getName(),
        RequestBody.create(MediaType.parse("multipart/form-data"), path))
        .build()

        local request = Request.Builder()
        .url("https://img.legado.cn/upload")
        .header("Referer","https://img.legado.cn/")
        .header("x-csrf-token",x_csrf_token)
        .header("Cookie",cookie)
        .post(requestBody)
        .build();
        local okhttp = OkHttpClient();
        local callx = okhttp.newCall(request);
        callx.enqueue(Callback{
          onFailure=function( call, e)
            --请求失败
            print("哦哦，失败了")
            --zhacai(String(e.body().bytes()).toString())
          end,
          onResponse=function(call, response)
            --请求成功
            local code=response.code()
            local header=response.headers()
            local data=response.body().string()
            zhacai(code,data,header)

          end
        });

       else
        print("失败:"..code)
      end
    end)
   else
    print("目录为空,该目录无法获取")
  end
end

local function Upload_pictures(fileSrc)
  Http_upload(fileSrc,function(code,data,head) --print(code,heaf)
    if code==200 then
      local cjson=require("cjson")
      local json=cjson.decode(data)
      -- print(data)
      if json.status then
        print(json.message)
        pcall(function() edit_text.text=json.data.links.url end)
        copy(json.data.links.url)
       else
        print("失败",json.message)
      end
     else
      print("失败:"..code)
    end
  end)
end
function popup(v,i)
  import "android.content.res.ColorStateList"
  import "androidx.appcompat.widget.PopupMenu"
  local Color = luajava.bindClass "android.graphics.Color"
  local colorAccent1=Color.parseColor(this.UiManager.colors.colorAccent)
  local textColorPrimary1=Color.parseColor(this.UiManager.colors.textColorPrimary)

  local popupMenu=PopupMenu(activity,v)
  local menu=popupMenu.menu
  if i==1 then
    menu.add("牛图网").setIcon(R.drawable.mtrl_ic_arrow_drop_up).setIconTintList(ColorStateList.valueOf(colorAccent1))
   elseif i==2 then
    menu.add("居左").setIcon(R.drawable.material_ic_keyboard_arrow_left_black_24dp).setIconTintList(ColorStateList.valueOf(colorAccent1))
    menu.add("居中").setIcon(R.drawable.mtrl_ic_arrow_drop_up).setIconTintList(ColorStateList.valueOf(colorAccent1))
    menu.add("居右").setIcon(R.drawable.material_ic_keyboard_arrow_right_black_24dp).setIconTintList(ColorStateList.valueOf(colorAccent1))
  end
  menu.setOptionalIconsVisible(true)

  popupMenu.onMenuItemClick=function(item)
    switch item.title
     case "牛图网"
      local bundle=Bundle()
      bundle.putString("url","https://www.niupic.com/")
      --bundle.putInt("key",0)
      activity.startFusionActivity("Browsepage",bundle)

     case "居左"
      加载Js([[var str = window.getSelection().toString();
          if (str){
             changeText("needmessage","[align=left]","[/align]")
          }else{
             insertText(document.getElementById('needmessage'),"[align=left][/align]");
          }]])
     case "居中"
      加载Js([[var str = window.getSelection().toString();
          if (str){
             changeText("needmessage","[align=center]","[/align]")
          }else{
             insertText(document.getElementById('needmessage'),"[align=center][/align]");
          }]])
     case "居右"
      加载Js([[var str = window.getSelection().toString();
          if (str){
             changeText("needmessage","[align=right]","[/align]")
          }else{
             insertText(document.getElementById('needmessage'),"[align=right][/align]");
          }]])
    end
  end
  popupMenu.show()
end

import "com.google.android.material.chip.Chip"
local layout={
  LinearLayout;
  layout_width="fill";
  id="bottom",
  layout_height="40dp";
  visibility='gone';--隐藏控件
  background=colorBackground;--布局背景
  orientation='horizontal';--布局方向
  {
    RecyclerView,
    id="recycler_view",
    layout_width="match",
    layout_height="wrap",
  },
};

local list_item={
  LinearLayout,
  layout_width="wrap",
  layout_height="wrap",
  {
    Chip;
    layout_width="wrap";
    layout_height="match_parent";
    layout_marginLeft='5dp';--布局左距
    layout_marginRight='5dp';--布局右距
    id="text",
    TextSize="15";
    TextColor=colorTextPrimary;
  };
}
local viewGroup=this.uiManager.getViewPager().parent
viewGroup.addView(loadlayout(layout))
recycler_view.layoutManager=LinearLayoutManager(activity)
recycler_view.layoutManager.setOrientation(0)

local cjson=require("cjson")
local data=cjson.decode(this.getSharedData("Menulist"))

local adapter=LuaRecyclerAdapter(activity,data,list_item)
adapter.clickViewId="text"
adapter.onItemClick=function(adapter,itemView,view,pos)
  --简单获取到当前item的Data表
  local itemData = adapter.Data[pos+1]
  switch(itemData.text)
   case "加粗"
    加载Js([[
        var str = window.getSelection().toString();
        //var strtxt=document.getElementById("needmessage").value;
        if (str){
            changeText("needmessage","[b]","[/b]")
            // document.getElementById("needmessage").value=strtxt.replace(str,"[b]"+str+"[/b]");
        }else{
             //popup.open('请选中一段文字', 'alert');
             insertText(document.getElementById('needmessage'),"[b][/b]");
        }
        ]])
   case "斜体"
    加载Js([[
        var str = window.getSelection().toString();
        //var strtxt=document.getElementById("needmessage").value;
        if (str){
             changeText("needmessage","[i]","[/i]")
             //document.getElementById("needmessage").value=strtxt.replace(str,"[i]"+str+"[/i]");
        }else{
             //popup.open('请选中一段文字', 'alert');
             insertText(document.getElementById('needmessage'),"[i][/i]");
        }
        ]])
   case "下划线"
    加载Js([[
        var str = window.getSelection().toString();
        //var strtxt=document.getElementById("needmessage").value;
        if (str){
             changeText("needmessage","[u]","[/u]")
             //document.getElementById("needmessage").value=strtxt.replace(str,"[u]"+str+"[/u]");
        }else{
             //popup.open('请选中一段文字', 'alert');
             insertText(document.getElementById('needmessage'),"[u][/u]");
        }
        ]])
   case "删除线"
    加载Js([[
        var str = window.getSelection().toString();
        //var strtxt=document.getElementById("needmessage").value;
        if (str){
             changeText("needmessage","[s]","[/s]")
             //document.getElementById("needmessage").value=strtxt.replace(str,"[s]"+str+"[/s]");
        }else{
             //popup.open('请选中一段文字', 'alert');
             insertText(document.getElementById('needmessage'),"[s][/s]");
        }
        ]])
   case "字号文字"
    加载Js([[
        popup.open('文字大小可选1~9', 'alert');
        var str = window.getSelection().toString();
        //var strtxt=document.getElementById("needmessage").value;
        if (str){
             changeText("needmessage","[size=1~9]","[/size]")
             //document.getElementById("needmessage").value=strtxt.replace(str,"[size=1~9]"+str+"[/size]");
        }else{
             //popup.open('请选中一段文字', 'alert');
             insertText(document.getElementById('needmessage'),"[size=1~9][/size]");
        }
        ]])
   case "颜色文字"

    function CircleButton(view,InsideColor)
      import "android.graphics.drawable.GradientDrawable"
      drawable = GradientDrawable()
      drawable.setShape(GradientDrawable.RECTANGLE)
      drawable.setColor(InsideColor)
      drawable.setCornerRadii({360,360,360,360,360,360,360,360});
      view.setBackgroundDrawable(drawable)
    end
    import "com.google.android.material.card.MaterialCardView"

    local yuxuan={
      LinearLayout;
      orientation="vertical";
      layout_height="fill";
      layout_width="fill";
      gravity="center",
      {
        MaterialCardView,
        layout_height="100dp";
        layout_width="100dp";
        id="mmp5",
      };

      {
        TextView,
        text="#000000",
        id="mmp4",
        layout_width="80%w";
        layout_height="50dp";
        gravity="center",
      };
      --滑条一
      {
        FrameLayout;
        layout_height="50dp";
        layout_width="fill";
        {
          TextView,
          text="R",
          layout_gravity="left",
          layout_width="10%w";
          layout_height="50dp";
          gravity="center",
        };
        {
          SeekBar;
          id="seek_red";
          max=255;
          progress=1;
          layout_gravity="center",
          layout_width="70%w";
          layout_height="50dp";
        },
        {
          TextView,
          layout_gravity="right",
          text="00",
          id="mmp1",
          layout_width="10%w";
          layout_height="50dp";
          gravity="center",
        };
      },


      --滑条二
      {
        FrameLayout;
        layout_height="50dp";
        layout_width="fill";
        {
          TextView,
          layout_gravity="left",
          text="G",
          layout_width="10%w";
          layout_height="50dp";
          gravity="center",
        };
        {
          SeekBar;
          id="seek_green";
          max=255;
          progress=1;
          layout_gravity="center",
          layout_width="70%w";
          layout_height="50dp";
        },
        {
          TextView,
          text="00",
          id="mmp2",
          layout_gravity="right",
          layout_width="10%w";
          layout_height="50dp";
          gravity="center",
        };
      },

      --滑条三
      {
        FrameLayout;
        layout_height="50dp";
        layout_width="fill";
        {
          TextView,
          text="B",
          layout_gravity="left",
          layout_width="10%w";
          layout_height="50dp";
          gravity="center",
        };
        {
          SeekBar;
          max=255;
          progress=1;
          id="seek_blue";
          layout_gravity="center",
          layout_width="70%w";
          layout_height="50dp";
        },
        {
          TextView,
          text="00",
          layout_gravity="right",
          id="mmp3",
          layout_width="10%w";
          layout_height="50dp";
          gravity="center",
        };
      },
    }

    local 取色器=loadlayout(yuxuan)
    local PorterDuff = luajava.bindClass "android.graphics.PorterDuff"
    local PorterDuffColorFilter = luajava.bindClass "android.graphics.PorterDuffColorFilter"
    seek_red.ProgressDrawable.setColorFilter(PorterDuffColorFilter(0xFFFF0000,PorterDuff.Mode.SRC_ATOP))
    seek_red.Thumb.setColorFilter(PorterDuffColorFilter(0xFFFF0000,PorterDuff.Mode.SRC_ATOP))

    seek_green.ProgressDrawable.setColorFilter(PorterDuffColorFilter(0xFF00FF00,PorterDuff.Mode.SRC_ATOP))
    seek_green.Thumb.setColorFilter(PorterDuffColorFilter(0xFF00FF00,PorterDuff.Mode.SRC_ATOP))

    seek_blue.ProgressDrawable.setColorFilter(PorterDuffColorFilter(0xFF0000FF,PorterDuff.Mode.SRC_ATOP))
    seek_blue.Thumb.setColorFilter(PorterDuffColorFilter(0xFF0000FF,PorterDuff.Mode.SRC_ATOP))

    CircleButton(mmp5,0xFF000000)


    --SeekBar绑定监听(一个接口，三个方法)
    seek_red.setOnSeekBarChangeListener{
      onProgressChanged=function(SeekBar,progress)
        local progress=progress+1
        local a=string.upper(Integer.toHexString(progress-1))
        if #a==1 then
          a="0"..a
        end
        mmp1.setText(a)
        local d=mmp1.getText()..mmp2.getText()..mmp3.getText()
        mmp4.setText("#"..d)
        CircleButton(mmp5,int("0xFF"..d))
      end
    }


    seek_green.setOnSeekBarChangeListener{
      onProgressChanged=function(SeekBar,progress)
        local progress=progress+1
        local b=string.upper(Integer.toHexString(progress-1))
        if #b==1 then
          b="0"..b
        end
        mmp2.setText(b)
        local d=mmp1.getText()..mmp2.getText()..mmp3.getText()
        mmp4.setText("#"..d)
        CircleButton(mmp5,int("0xFF"..d))
      end
    }

    seek_blue.setOnSeekBarChangeListener{
      onProgressChanged=function(SeekBar,progress)
        local progress=progress+1
        local c=string.upper(Integer.toHexString(progress-1))
        if #c==1 then
          c="0"..c
        end
        mmp3.setText(c)
        local d=mmp1.getText()..mmp2.getText()..mmp3.getText()
        mmp4.setText("#"..d)
        CircleButton(mmp5,int("0xFF"..d))
      end
    }

    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    local dialog=MaterialAlertDialogBuilder(activity)
    .setView(取色器)
    .setTitle("选色器")
    .setPositiveButton("确定", {
      onClick=function(view)
        加载Js([[
        var str = window.getSelection().toString();
        //var strtxt=document.getElementById("needmessage").value;
        if (str){
            changeText("needmessage","[color=]]..mmp4.getText()..[[]","[/color]")
            //insertText(document.getElementById('needmessage'),"[color=]]..mmp4.getText()..[[]"+str+"[/color]");
            //document.getElementById("needmessage").value=strtxt.replace(str,"[color=]]..mmp4.getText()..[[]"+str+"[/color]");
        }else{
             //popup.open('请选中一段文字', 'alert');
             insertText(document.getElementById('needmessage'),"[color=]]..mmp4.getText()..[[][/color]");
        }
        ]])
      end
    })
    .setNeutralButton("取消",nil)
    .show()
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)

   case "彩色文字"
    加载Js([[
        var str = window.getSelection().toString();
        //var strtxt=document.getElementById("needmessage").value;
        if (str){
set_rainbow(str, "0000FF","FF0000");
function set_rainbow(wr_text, wr_rgb1, wr_rgb2) { //设置彩虹文字
    var wr_code, wr_rgb, r, g, b, i, j, istep;
    var r1, g1, b1, r2, g2, b2;
    r1 = g1 = b1 = r2 = g2 = b2 = 0;
    r = 0;
    g = 0;
    b = 0;
    istep = 0;
    wr_code = '';
    istep = 40;
    r = 255;
    i = 1;
    j = 0;
    do {
        if (wr_text.charCodeAt(j) != 32) {
            if (g + istep < 256) {
                if (i == 1) g += istep;
            } else if (i == 1) {
                i = 2;
                g = 255;
            }
            if (r - istep > -1) {
                if (i == 2) r -= istep;
            } else if (i == 2) {
                i = 3;
                r = 0;
            }
            if (b + istep < 256) {
                if (i == 3) b += istep;
            } else if (i == 3) {
                i = 4;
                b = 255;
            }
            if (g - istep > -1) {
                if (i == 4) g -= istep;
            } else if (i == 4) {
                i = 5;
                g = 0;
            }
            if (r + istep < 256) {
                if (i == 5) r += istep;
            } else if (i == 5) {
                i = 6;
                r = 255;
            }
            if (b - istep > -1) {
                if (i == 6) b -= istep;
            } else if (i == 6) {
                i = 1;
                b = 0;
            }
            wr_rgb = '';
            wr_rgb += parseInt(r).toString(16).length == 1 ? 0 + parseInt(r).toString(16) : parseInt(r).toString(16);
            wr_rgb += parseInt(g).toString(16).length == 1 ? 0 + parseInt(g).toString(16) : parseInt(g).toString(16);
            wr_rgb += parseInt(b).toString(16).length == 1 ? 0 + parseInt(b).toString(16) : parseInt(b).toString(16);
            wr_rgb = wr_rgb.toUpperCase();
            wr_code += '[color=#' + wr_rgb + ']' + wr_text.charAt(j) + '[/color]';
        } else {
            wr_code += wr_text.charAt(j);
        }
        j++;
    } while ( j < wr_text.length );
    changeText("needmessage",wr_code);
    //document.getElementById("needmessage").value=strtxt.replace(wr_text,wr_code);
    }
        }else{
             popup.open('请选中一段文字', 'alert');
        }
        ]])
   case "URL 超连接"
    Input_field("URL")
   case "Email 超连接"
    Input_field("Email")
   case "网络图片"
    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    import "android.content.res.ColorStateList"
    local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
    local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
    local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"
    local view_table=
    {LinearLayout;--线性控件
      orientation='vertical';--布局方向
      layout_width="match",
      layout_height="match",
      {FrameLayout,
        layout_width="match",
        layout_height="match",
        {TextInputLayout,
          id="input_layout",
          layout_height="wrap",
          layout_marginLeft="20dp",
          layout_marginRight="20dp",
          prefixText="* ",
          prefixTextColor=ColorStateList.valueOf(0xffff0000),
          suffixText="ㅤ  ㅤ",
          --error="错误提示",
          layout_width="match",
          hint="请输入链接",--设置输入框提示文本
          {TextInputEditText,
            id="edit_text",
            singleLine=true;--设置单行输入，禁止换行
            --layout_marginRight='25dp';
            layout_height="wrap",
            layout_width="match",
          },
        },
        {
          ImageView;--图片控件
          layout_width='25dp';--图片宽度
          layout_height='25dp';--图片高度
          src='Upload.png';--图片路径
          id='image';--设置控件ID
          --ColorFilter='';--图片着色
          ColorFilter=textColorSecondary;--设置图片着色
          scaleType='fitXY';--图片拉伸
          layout_marginRight='30dp';
          --layout_marginTop='5dp';--布局顶距
          layout_gravity='center|right';--重力
        };
      },
      {
        CheckBox;--复选控件
        layout_width='fill';--控件宽度
        layout_height='fill';--控件高度
        id="check",
        layout_marginLeft="18dp",
        text='点击图片，打开图片链接';--显示文字
        textSize='16sp';--文字大小
        textColor=textColorSecondary;--文字颜色
      };
    }

    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle("网络图片")
    .setView(loadlayout(view_table))
    .setPositiveButton("确定",nil)
    .setNegativeButton("取消",nil)
    .setNeutralButton("其他图床",nil)
    .show()
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)

    task(100,function()
      local Context = luajava.bindClass "android.content.Context"
      import "android.view.inputmethod.InputMethodManager"
      edit_text.getContext().getSystemService(Context.INPUT_METHOD_SERVICE).toggleSoftInput(0,InputMethodManager.HIDE_NOT_ALWAYS)
      edit_text.requestFocus()
    end)
    dialog.getButton(AlertDialog.BUTTON1).onClick=function()
      local text=edit_text.text
      if text=="" then
        input_layout.setError("链接不可为空")
       else
        if check.checked then
          加载Js([[
           insertText(document.getElementById('needmessage'),"[url=]]..text..'][img]'..text..[[[/img][/url]\n");
          ]])
         else
          加载Js([==[
           insertText(document.getElementById('needmessage'),"[img]]==]..text..[[[/img]\n");
          ]])
        end
        dialog.hide()
      end
    end
    dialog.getButton(AlertDialog.BUTTON3).onClick=function(v)
      popup(v,1)
    end
    edit_text.addTextChangedListener{
      onTextChanged=function()
        --事件
        if edit_text.text=="" then
          input_layout.setError("链接不可为空")
         else
          input_layout.setError(null)
        end
      end
    }
    import "android.graphics.Color"
    波纹(image,Color.parseColor(colorAccent))
    image.onClick=function(v)--控件点击事件
      local Intent = luajava.bindClass "android.content.Intent"
      local intent=Intent("android.intent.action.GET_CONTENT")
      .setType("image/*")
      .addCategory("android.intent.category.OPENABLE")
      activity.startActivityForResult(intent,1)
      function onActivityResult(requestCode,resultCode,data)
        if data then
          import "uri2path"
          Upload_pictures(uri2path(data.data))
        end
      end
    end;
   case "水平线"
    加载Js([[
     insertText(document.getElementById('needmessage'),'[hr]\n');
    ]])
   case "对齐文本"
    popup(view,2)
   case "代码文本"
    加载Js([[var str = window.getSelection().toString();
          if (str){
             changeText("needmessage","[code]","[/code]")
          }else{
             insertText(document.getElementById('needmessage'),"[code][/code]");
          }]])
   case "引用文本"
    加载Js([[var str = window.getSelection().toString();
          if (str){
             changeText("needmessage","[quote]","[/quote]")
          }else{
             insertText(document.getElementById('needmessage'),"[quote][/quote]");
          }]])
   case "隐藏文本"
    加载Js([[var str = window.getSelection().toString();
          if (str){
             changeText("needmessage","[hide]","[/hide]")
          }else{
             insertText(document.getElementById('needmessage'),"[hide][/hide]");
          }]])
   case "表格"
    加载Js([[
     popup.open('请自行搭配使用', 'alert');
     insertText(document.getElementById('needmessage'),'[table][tr][td]文本[/td][/tr][/table]\n');
    ]])
   case "网络视频"
    加载Js([[var str = window.getSelection().toString();
          if (str){
             changeText("needmessage","[media=x,500,375]","[/media]")
          }else{
             insertText(document.getElementById('needmessage'),"[media=x,500,375]视频地址[/media]");
          }]])
   case "列表"
    加载Js([[
     popup.open('请自行搭配使用', 'alert');
     insertText(document.getElementById('needmessage'),`[list=A]
[*] list可以是字母或者数字。
[*] 他将会自动依次排列。
[/list]\n`);
    ]])
   case "联系QQ"
    加载Js([[
     insertText(document.getElementById('needmessage'),'[qq]QQ号[/qq]\n');
    ]])
   default
    加载Js([[
     insertText(document.getElementById('needmessage'),']]..adapter.Data[pos+1].Content..[[');
    ]])
  end
end
recycler_view.adapter=adapter