--
-- @author 寒歌
-- @description Main是应用的主模块，其中注册了应用运行中UI事件的回调、Activity生命周期的回调等
-- 你也可以在此编写启动事件代码，或控制应用运行逻辑、自定义应用UI等等。
-- @other 本模版已为你编写好基础事件，建议在阅读注释并理解相关参数意义后再进行扩展编写
--

-- ****默认导入包****
require "import"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
-- ****不需要请删除****
import "android.webkit.CookieManager"
import "net.fusionapp.core.ui.fragment.WebInterface"


fragment=activity.uiManager.currentFragment
web=fragment.webView

-- @param data 侧滑栏列表的全部数据
-- @param recyclerView 侧滑栏列表控件
-- @param listIndex 点击的列表索引（点击的是第几个列表）
-- @param clickIndex 点击的项目索引（点击的第几个项目）
function onDrawerListItemClick(data, recyclerView, listIndex, itemIndex)
  --侧滑栏列表的数据是二维结构，所以需要先获取到点击项目所在列表的数据
  local listData = data.get(listIndex);
  --获取到所在列表的数据后获取点击项目的数据
  local itemData = listData.get(itemIndex);
  --最后获取到点击的项目的标题
  local itemTitle = itemData.getTitle();

  --TODO：
  print(itemTitle)
end

-- @param keyword 搜索栏输入的文本
-- @description 顶栏搜索功能回调事件
function onSearchEvent(keyword)
  --TODO：
  print("Search keyword:"..keyword)
end

-- @param title 点击的菜单标题
-- @description 顶栏菜单项目点击回调事件
function onMenuItemClick(title)
  switch title
   case "退出"
    activity.finish()
   case "复制链接"
    --先导入包
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.*"
    activity.getSystemService(Context.CLIPBOARD_SERVICE).setText(webView.getUrl())
   case "浏览器打开"
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.Intent"
    import "android.net.Uri"
    local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(webView.getUrl()))
    activity.startActivity(viewIntent)
   case "分享网页"
    import "androidx.core.app.ShareCompat"
    ShareCompat.IntentBuilder
    .from(activity)
    .setText(activity.uiManager.currentFragment.getWebView().getTitle().."\n"..activity.uiManager.currentFragment.getWebView().getUrl())
    .setType("text/plain")
    .startChooser();
   case "网页查找"
    uiManager=activity.getUiManager()
    --获取浏览器控件
    webView=uiManager.getCurrentFragment().getWebView()
    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    import "android.content.res.ColorStateList"
    local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
    local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
    local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"
    local WindowManager = luajava.bindClass "android.view.WindowManager"
    local view_table=
    {LinearLayout,
      layout_width="match",
      layout_height="match",
      orientation=1,
      {TextInputLayout,
        id="input_layout",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        layout_width="match",
        hint="内容",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text",
          text=this.getSharedData("lookup"),
          layout_height="wrap",
          layout_width="match",
        },
      },

    }
    local function onSearchEvent(input)
      if input then
        webView.findAllAsync(input)
       else
        webView.findNext(true)
      end
      this.setSharedData("lookup",input)
      return true
    end

    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle("网页查找")
    .setView(loadlayout(view_table))
    .setPositiveButton("下一个",nil)
    .setNegativeButton("取消",{
      onClick=function()
        webView.clearMatches()
      end
    })
    .show()
    dialog.getButton(AlertDialog.BUTTON1).onClick=function()
      onSearchEvent(edit_text.text)
    end
    local lp =dialog.getWindow().getAttributes()
    lp.alpha = 0.6
    dialog.getWindow().setAttributes(lp)
    --local ColorDrawable = luajava.bindClass "android.graphics.drawable.ColorDrawable"
    --dialog.getWindow().setBackgroundDrawable(ColorDrawable());
    local lp = dialog.getWindow().getAttributes();
    lp.dimAmount=0.0
    dialog.getWindow().setAttributes(lp);
    dialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);
    import "android.graphics.Color"
    local colorAccent=Color.parseColor(activity.getUiManager().getColors().colorAccent)
    import "android.content.res.ColorStateList"
    local colorRipple=ColorStateList.valueOf(0x44444444)
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)

  end
end

function dp2px(dpValue)
  local scale = activity.getResources().getDisplayMetrics().scaledDensity
  return dpValue * scale + 0.5
end

import "com.google.android.material.card.MaterialCardView"
import "com.google.android.material.bottomsheet.BottomSheetDialog"
import "android.content.res.ColorStateList"
import "android.graphics.drawable.GradientDrawable"

local BottomSheetDialogdrawable = GradientDrawable()
BottomSheetDialogdrawable.setShape(GradientDrawable.RECTANGLE)
BottomSheetDialogdrawable.setColor(0xffffffff)
BottomSheetDialogdrawable.setCornerRadii({dp2px(8),dp2px(8),dp2px(8),dp2px(8),0,0,0,0});


if activity.getPackageName()=="net.fusionapp" then
  R=luajava.bindClass "net.fusionapp.R"
 else
  R=luajava.bindClass "net.fusionapp.core.R"
end

function Ripple(view,color)
  import "android.content.res.ColorStateList"
  local attrsArray = {android.R.attr.selectableItemBackgroundBorderless}
  local typedArray =activity.obtainStyledAttributes(attrsArray)
  local ripple=typedArray.getResourceId(0,0)
  local Pretend=activity.Resources.getDrawable(ripple)
  Pretend.setColor(ColorStateList(int[0].class{int{}},int{color}))
  return Pretend.setColor(ColorStateList(int[0].class{int{}},int{color}))
end
local uiManager=this.uiManager
local colors=uiManager.getColors()
colorPrimary=colors.colorPrimary--主色
colorTextPrimary=colors.textColorPrimary--主文本色

function Dialog(title,content,mButton1,mButton2,mButton3,mButton1_,mButton2_,mButton3_)
  import "com.google.android.material.bottomsheet.BottomSheetDialog"
  mBottomSheetDialog=BottomSheetDialog(activity);
  mBottomSheetDialog.setContentView(loadlayout({
    LinearLayout;
    layout_height="match_parent";
    BackgroundDrawable=BottomSheetDialogDrawable;
    layout_width="match_parent";
    orientation="vertical";
    {
      LinearLayout;
      layout_marginTop="5dp";
      layout_width="-1";
      gravity="center";
      -- BackgroundColor="#FFFFFFFF";
      {
        MaterialCardView;
        layout_height="8dp";
        CardElevation="0dp";
        radius="4dp";
        layout_margin="5dp";
        layout_width="75dp";
        CardBackgroundColor="#FFF4F5F7";
      };
    };
    {
      TextView;
      layout_width="-1";
      layout_height="-2";
      textSize="20sp";
      layout_marginTop="9dp";
      layout_marginLeft="24dp";
      layout_marginRight="24dp";
      layout_marginBottom="0dp";
      Text=title;
      textStyle="bold";
      textColor=colorTextPrimary;
    };
    {
      ScrollView;
      layout_width="match_parent";
      layout_height="-2";
      layout_weight=100;
      {
        TextView;
        id="_view";
        textIsSelectable=true;
        text=content;
        paddingTop="8dp";
        paddingBottom="8dp";
        paddingRight="24dp";
        paddingLeft="24dp";
        layout_width="match_parent";
      };
    };
    {
      LinearLayout;
      layout_height="-2";
      layout_weight=1;
      layout_width="match_parent";
      orientation="vertical";
      {
        MaterialCardView;
        layout_weight=1;
        layout_height="50dp";
        CardElevation="3dp";
        radius="25dp";
        layout_marginTop="10dp";
        layout_marginRight="20dp";
        layout_marginLeft="20dp";
        layout_width="-1";
        CardBackgroundColor=0xff0984fd;
        onClick=mButton3_;
        {
          LinearLayout;
          layout_height="match_parent";
          gravity="center";
          layout_width="match_parent";
          focusable="true";
          {
            TextView;
            textStyle="bold";
            Text=mButton3;
            textColor=0xFFFFFFFF;
            textSize="15sp";
          };
        };
      };
      {
        LinearLayout;
        layout_height="-2";
        layout_width="match_parent";
        orientation="horizontal";
        {
          MaterialCardView;
          layout_weight=1;
          layout_height="50dp";
          CardElevation="3dp";
          radius="25dp";
          layout_marginTop="20dp";
          layout_marginRight="10dp";
          layout_marginLeft="20dp";
          layout_marginBottom="20dp";
          layout_width="-1";
          CardBackgroundColor=colorPrimary;
          onClick=mButton1_;
          {
            LinearLayout;
            layout_height="match_parent";
            gravity="center";
            layout_width="match_parent";
            focusable="true";
            {
              TextView;
              textStyle="bold";
              Text=mButton1;
              textColor=colorTextPrimary;
              textSize="15sp";
            };
          };
        };
        {
          MaterialCardView;
          layout_weight=1;
          layout_height="50dp";
          CardElevation="3dp";
          radius="25dp";
          layout_marginTop="20dp";
          layout_marginRight="20dp";
          layout_marginLeft="10dp";
          layout_marginBottom="20dp";
          layout_width="-1";
          CardBackgroundColor=colorPrimary;
          onClick=mButton2_;
          {
            LinearLayout;
            layout_height="match_parent";
            gravity="center";
            layout_width="match_parent";
            focusable="true";
            {
              TextView;
              textStyle="bold";
              Text=mButton2;
              textColor=colorTextPrimary;
              textSize="15sp";
            };
          };
        };
      };
    };
  })).getWindow().setDimAmount(0.5);
  if Build.VERSION.SDK_INT >= 21 then
    mBottomSheetDialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS);
  end
  mBottomSheetDialog.getWindow().findViewById(R.id.design_bottom_sheet).setBackgroundResource(android.R.color.transparent);
  mBottomSheetDialog.show();
  if content==nil then
    _view.setVisibility(View.GONE)
  end
end


--悬浮按钮点击事件
function onFloatingActionButtonClick(v)
  activity.uiManager.currentFragment.webView.reload()
end

local intent=activity.getIntent()
local uiManager=activity.getUiManager()
--获取当前页面的WebView
local webView=uiManager.getCurrentFragment().getWebView()
webView.loadUrl(intent.getStringExtra("url") or "https://img.ysqbbs.com/" or "www.baidu.com")


require"import"
import "net.fusionapp.core.ui.fragment.WebInterface"
local uimanager=activity.uiManager
local fragment=uimanager.currentFragment
fragment.setWebInterface(WebInterface{
  onPageFinished=function(view,url)
    --页面加载结束事件

  end,
  onPageStarted=function(view,url,favicon)
    --页面开始加载事件
  end,
  onReceivedTitle=function(view,title)
    --获取到网页标题时加载的事件
    local uiManager=this.uiManager
    local toolbar=uiManager.toolbar
    --设置toolbar标题
    toolbar.titleText=title

  end,
  onLoadResource=function(view,url)
    --页面资源加载监听
    --可通过该方法获取网页上的资源
  end,
  onUrlLoad=function(view,url)
    --即将开始加载事件，url参数是即将加载的url
    --该函数返回一个布尔值
    --返回true则拦截本次加载
    return false
  end,
  onReceivedSslError=function(view, sslErrorHandler, sslError)
    --ssl证书错误处理事件
    --需自行处理，请返回true拦截原事件
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.Intent"
    import "android.net.Uri"
    local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(webView.getUrl()))
    activity.startActivity(viewIntent)
    print("证书错误,已复制本页面链接\n请自行处理")
    return true
  end
})

local uiManager=activity.getUiManager()
local webView=uiManager.getCurrentFragment().getWebView()

local WebChromeClient = luajava.bindClass "android.webkit.WebChromeClient"
webView.setWebChromeClient(luajava.override(WebChromeClient,{
  onShowFileChooser=function(a, view, valueCallback, fileChooserParams)
    --print(a, view, valueCallback, fileChooserParams)
    uploadFile=valueCallback
    local intent = fileChooserParams.createIntent()

    local MimeTypeMap = luajava.bindClass "android.webkit.MimeTypeMap"
    local mimeTypeMap = MimeTypeMap.getSingleton()
    if not mimeTypeMap.hasMimeType(intent.getType()) then
      intent.setType("*/*")
    end
  
    activity.startActivityForResult(intent, 1);
    return true;
  end,
  onProgressChanged=function(a,view,progress)
    view.parent.getChildAt(2).progress=progress
  end,
  onReceivedTitle=function(a,view,title)
    local uiManager=this.uiManager
    local toolbar=uiManager.toolbar
    --设置toolbar标题
    toolbar.titleText=title
    local cjson=require("cjson")
    local data=cjson.decode(this.getSharedData("History"))
    table.insert(data,1,{PageName=activity.getLoader().getPageName(),Title=title,Text=view.getUrl()})
    local json=cjson.encode(data)
    this.setSharedData("History",json)
  end,
}))

onActivityResult=function(req,res,intent)
  local Activity = luajava.bindClass "android.app.Activity"
  local Uri = luajava.bindClass "android.net.Uri"
  if (res == Activity.RESULT_CANCELED) then
    if(uploadFile~=nil )then
      uploadFile.onReceiveValue(nil);
    end
  end
  local results
  if (res == Activity.RESULT_OK)then
    if(uploadFile==nil or type(uploadFile)=="number")then
      return;
    end
    if (intent ~= nil) then
      local dataString = intent.getDataString();
      local clipData = intent.getClipData();
      if (clipData ~= nil) then
        results = Uri[clipData.getItemCount()];
        for i = 0,clipData.getItemCount()-1 do
          local item = clipData.getItemAt(i);
          results[i] = item.getUri();
        end
      end
      if (dataString ~= nil) then
        results = Uri[1];
        results[0]=Uri.parse(dataString)
      end
    end
  end
  if(results~=nil)then
    uploadFile.onReceiveValue(results);
    uploadFile = nil;
  end
end

local Context = luajava.bindClass "android.content.Context"
local Uri = luajava.bindClass "android.net.Uri"
import "android.app.DownloadManager"
import "android.webkit.DownloadListener"
function downloadFile(url,filepath,filename)
  downloadManager=activity.getSystemService(Context.DOWNLOAD_SERVICE);
  url=Uri.parse(url);
  print("已开始下载，请在通知栏查看进度\n存储在Download目录")
  request=DownloadManager.Request(url);
  request.setAllowedNetworkTypes(DownloadManager.Request.NETWORK_MOBILE|DownloadManager.Request.NETWORK_WIFI);
  request.setDestinationInExternalPublicDir(filepath,filename);
  request.setNotificationVisibility(DownloadManager.Request.VISIBILITY_VISIBLE_NOTIFY_COMPLETED);
  downloadManager.enqueue(request);
end
local uiManager=activity.getUiManager()
--获取当前页面的WebView
local webView=uiManager.getCurrentFragment().getWebView()

webView.setDownloadListener(DownloadListener{
  onDownloadStart=function(url,userAgent,contentDisposition,mimetype,contentLength)
    local filepath="/Download"--下载目录
    local URLUtil = luajava.bindClass "android.webkit.URLUtil"
    filename=URLUtil.guessFileName(url, contentDisposition, mimeType);
    --sock=require"socket.url"
    import "java.net.URLDecoder"
    local filename=URLDecoder.decode(filename)
    Dialog("下载文件","即将下载 "..filename.."\n链接:\n"..url,"复制链接","浏览器下载","直接下载",
    function()
      mBottomSheetDialog.dismiss()
      activity.getSystemService("clipboard").setText(url)
    end,
    function()
      mBottomSheetDialog.dismiss()
      import "android.content.Intent"
      import "android.net.Uri"
      local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(url))
      activity.startActivity(viewIntent)
    end,
    function()
      mBottomSheetDialog.dismiss()
      downloadFile(url,filepath,filename)
    end)
  end
})