--
-- @author 寒歌
-- @description Main是应用的主模块，其中注册了应用运行中UI事件的回调、Activity生命周期的回调等
-- 你也可以在此编写启动事件代码，或控制应用运行逻辑、自定义应用UI等等。
-- @other 本模版已为你编写好基础事件，建议在阅读注释并理解相关参数意义后再进行扩展编写
--

-- ****默认导入包****
require "import"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
-- ****不需要请删除****

-- @param data 侧滑栏列表的全部数据
-- @param recyclerView 侧滑栏列表控件
-- @param listIndex 点击的列表索引（点击的是第几个列表）
-- @param clickIndex 点击的项目索引（点击的第几个项目）
function onDrawerListItemClick(data, recyclerView, listIndex, itemIndex)
  --侧滑栏列表的数据是二维结构，所以需要先获取到点击项目所在列表的数据
  local listData = data.get(listIndex);
  --获取到所在列表的数据后获取点击项目的数据
  local itemData = listData.get(itemIndex);
  --最后获取到点击的项目的标题
  local itemTitle = itemData.getTitle();

  --TODO：
  print(itemTitle)
end

-- @param keyword 搜索栏输入的文本
-- @description 顶栏搜索功能回调事件
function onSearchEvent(keyword)
  --TODO：
  print("Search keyword:"..keyword)
end

-- @param title 点击的菜单标题
-- @description 顶栏菜单项目点击回调事件
function onMenuItemClick(title)
  switch title

   case "退出"
    activity.finish()
   case "复制链接"
    --先导入包
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.*"
    activity.getSystemService(Context.CLIPBOARD_SERVICE).setText(webView.getUrl())
   case "浏览器打开"
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.Intent"
    import "android.net.Uri"
    local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(webView.getUrl()))
    activity.startActivity(viewIntent)
   case "刷新"
    activity.uiManager.currentFragment.webView.reload()
   case "网页查找"
    uiManager=activity.getUiManager()
    --获取浏览器控件
    webView=uiManager.getCurrentFragment().getWebView()
    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    import "android.content.res.ColorStateList"
    local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
    local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
    local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"
    local WindowManager = luajava.bindClass "android.view.WindowManager"
    local view_table=
    {LinearLayout,
      layout_width="match",
      layout_height="match",
      orientation=1,
      {TextInputLayout,
        id="input_layout",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        layout_width="match",
        hint="内容",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text",
          text=this.getSharedData("lookup"),
          layout_height="wrap",
          layout_width="match",
        },
      },

    }
    local function onSearchEvent(input)
      if input then
        webView.findAllAsync(input)
       else
        webView.findNext(true)
      end
      this.setSharedData("lookup",input)
      return true
    end

    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle("网页查找")
    .setView(loadlayout(view_table))
    .setPositiveButton("下一个",nil)
    .setNegativeButton("取消",{
      onClick=function()
        webView.clearMatches()
      end
    })
    .show()
    dialog.getButton(AlertDialog.BUTTON1).onClick=function()
      onSearchEvent(edit_text.text)
    end
    local lp =dialog.getWindow().getAttributes()
    lp.alpha = 0.6
    dialog.getWindow().setAttributes(lp)
    --local ColorDrawable = luajava.bindClass "android.graphics.drawable.ColorDrawable"
    --dialog.getWindow().setBackgroundDrawable(ColorDrawable());
    local lp = dialog.getWindow().getAttributes();
    lp.dimAmount=0.0
    dialog.getWindow().setAttributes(lp);
    dialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);
    import "android.graphics.Color"
    local colorAccent=Color.parseColor(activity.getUiManager().getColors().colorAccent)
    import "android.content.res.ColorStateList"
    local colorRipple=ColorStateList.valueOf(0x44444444)
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
   case "分享网页"
    import "androidx.core.app.ShareCompat"
    ShareCompat.IntentBuilder
    .from(activity)
    .setText(activity.uiManager.currentFragment.getWebView().getTitle().."\n"..activity.uiManager.currentFragment.getWebView().getUrl())
    .setType("text/plain")
    .startChooser();
  end
end


--悬浮按钮点击事件
function onFloatingActionButtonClick(v)
  --TODO：onFloatingActionButtonClick
  activity.getUiManager().getCurrentFragment().getWebView().evaluateJavascript("goTop();",function end)
end

local intent=activity.getIntent()
local uiManager=activity.getUiManager()
--获取当前页面的WebView
local webView=uiManager.getCurrentFragment().getWebView()
webView.loadUrl(intent.getStringExtra("url") or "https://ysqbbs.com/group.php?mobile=2")


import "android.webkit.WebViewClient"
webView.setWebViewClient(luajava.override(WebViewClient,{
  onReceivedError=function(_,view,webResourceRequest,webResourceError)
    --连接错误事件
  end,
  onPageFinished=function(_,view,url)
    --页面加载结束事件
    if this.getSharedData("显示FPS")=="true" then
      view.evaluateJavascript("Display_fps();",function end)
    end
    
  end,
  shouldOverrideUrlLoading=function(_,view,webResourceRequest)
    local url=tostring(webResourceRequest.getUrl())
    --页面即将加载
    local packageName4=url:match'ysqbbs%.com/thread%-.+%-.+%-.+%.html'
    local packageName17=url:match'ysqbbs%.com/forum%.php%?mod=forumdisplay&action=list&fid=.+'
    if packageName4 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Detailsofthepost",bundle)
      return true
     elseif packageName17 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Plate",bundle)
      return true

     else
      return false
    end
  end,
  onPageStarted=function(_,view,url,bitmap)
    --页面开始加载
  end,
  onReceivedSslError=function(a, view, sslErrorHandler, sslError)
    --ssl证书错误处理事件
    --需自行处理，请返回true拦截原事件
    -- print("WebViewClient遇到了SSL错误")
    return true
  end
}))
local WebChromeClient = luajava.bindClass "android.webkit.WebChromeClient"
webView.setWebChromeClient(luajava.override(WebChromeClient,{
  onProgressChanged=function(a,view,progress)
    view.parent.getChildAt(2).progress=progress
  end,
  onReceivedTitle=function(a,view,title)
    local uiManager=this.uiManager
    local toolbar=uiManager.toolbar
    --设置toolbar标题
    toolbar.titleText=title
    local cjson=require("cjson")
    local data=cjson.decode(this.getSharedData("History"))
    table.insert(data,1,{PageName=activity.getLoader().getPageName(),Title=title,Text=view.getUrl()})
    local json=cjson.encode(data)
    this.setSharedData("History",json)
  end,
}))