--
-- @author 寒歌
-- @description Main是应用的主模块，其中注册了应用运行中UI事件的回调、Activity生命周期的回调等
-- 你也可以在此编写启动事件代码，或控制应用运行逻辑、自定义应用UI等等。
-- @other 本模版已为你编写好基础事件，建议在阅读注释并理解相关参数意义后再进行扩展编写
--

-- ****默认导入包****
require "import"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
-- ****不需要请删除***
-- @param data 侧滑栏列表的全部数据
-- @param recyclerView 侧滑栏列表控件
-- @param listIndex 点击的列表索引（点击的是第几个列表）
-- @param clickIndex 点击的项目索引（点击的第几个项目）
function onDrawerListItemClick(data, recyclerView, listIndex, itemIndex)
  --侧滑栏列表的数据是二维结构，所以需要先获取到点击项目所在列表的数据
  local listData = data.get(listIndex);
  --获取到所在列表的数据后获取点击项目的数据
  local itemData = listData.get(itemIndex);
  --最后获取到点击的项目的标题
  local itemTitle = itemData.getTitle();

  --TODO：
  print(itemTitle)
end
--电脑版
-- @param keyword 搜索栏输入的文本
-- @description 顶栏搜索功能回调事件
function onSearchEvent(keyword)
  --TODO：
  print("Search keyword:"..keyword)
end
--[[
import "net.fusionapp.core.ui.adapter.BasePagerAdapter"
UiManager=this.UiManager
local viewPager=UiManager.viewPager
--加载layout
local list=ArrayList()
list.add(loadlayout("layout"))

viewPager.setAdapter(BasePagerAdapter(list))
]]
local uiManager=activity.getUiManager()
--获取当前页面的WebView
local webView=uiManager.getCurrentFragment().getWebView()

-- @param title 点击的菜单标题
-- @description 顶栏菜单项目点击回调事件
function onMenuItemClick(title)
  switch title
   case "退出"
    activity.finish()
   case "复制链接"
    --先导入包
    import "android.content.*"
    activity.getSystemService(Context.CLIPBOARD_SERVICE).setText(webView.getUrl())
   case "浏览器打开"
    import "android.content.Intent"
    import "android.net.Uri"
    local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(webView.getUrl()))
    activity.startActivity(viewIntent)
    case "网页查找"
    
    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    import "android.content.res.ColorStateList"
    local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
    local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
    local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"
    local WindowManager = luajava.bindClass "android.view.WindowManager"
    local view_table=
    {LinearLayout,
      layout_width="match",
      layout_height="match",
      orientation=1,
      {TextInputLayout,
        id="input_layout",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        layout_width="match",
        hint="内容",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text",
          text=this.getSharedData("lookup"),
          layout_height="wrap",
          layout_width="match",
        },
      },

    }
    local function onSearchEvent(input)
      if input then
        webView.findAllAsync(input)
       else
        webView.findNext(true)
      end
      this.setSharedData("lookup",input)
      return true
    end

    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle("网页查找")
    .setView(loadlayout(view_table))
    .setPositiveButton("下一个",nil)
    .setNegativeButton("取消",{
      onClick=function()
        webView.clearMatches()
      end
    })
    .show()
    dialog.getButton(AlertDialog.BUTTON1).onClick=function()
      onSearchEvent(edit_text.text)
    end
    local lp =dialog.getWindow().getAttributes()
    lp.alpha = 0.6
    dialog.getWindow().setAttributes(lp)
    --local ColorDrawable = luajava.bindClass "android.graphics.drawable.ColorDrawable"
    --dialog.getWindow().setBackgroundDrawable(ColorDrawable());
    local lp = dialog.getWindow().getAttributes();
    lp.dimAmount=0.0
    dialog.getWindow().setAttributes(lp);
    dialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);
    import "android.graphics.Color"
    local colorAccent=Color.parseColor(activity.getUiManager().getColors().colorAccent)
    import "android.content.res.ColorStateList"
    local colorRipple=ColorStateList.valueOf(0x44444444)
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)

  end
end


--悬浮按钮点击事件
function onFloatingActionButtonClick(v)
  webView.reload()
end

print"电脑版不提供任何功能，仅供浏览"
--[[
webView.requestFocusFromTouch()--设置支持获取手势焦点

webView.getSettings().setSupportZoom(true); --支持网页缩放
webView.getSettings().setBuiltInZoomControls(true); --支持缩放
webView.getSettings().setLoadWithOverviewMode(true);--缩放至屏幕的大小
webView.getSettings().setDisplayZoomControls(false); --隐藏自带的右下角缩放控件
webView.getSettings().setUseWideViewPort(true) --图片自适应


webView.getSettings().setUserAgentString('Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/50.0.2661.87 Safari/537.36')--设置浏览器标识(UA)

webView.setWebChromeClient(luajava.override(luajava.bindClass "android.webkit.WebChromeClient",{
  onReceivedTitle=function(super,view,title)
    --获取到网页标题
    local uiManager=this.uiManager
    local toolbar=uiManager.toolbar
    --设置toolbar标题
    toolbar.titleText=title
  end,
  
  
}))
]]

local intent=activity.getIntent()
webView.loadUrl(intent.getStringExtra("url") or "https://ysqbbs.com/" or "https://ysqbbs.com/")



require"import"
import "net.fusionapp.core.ui.fragment.WebInterface"
local uimanager=activity.uiManager
local fragment=uimanager.currentFragment
fragment.setWebInterface(WebInterface{
  onPageFinished=function(view,url)
    --页面加载结束事件

  end,
  onPageStarted=function(view,url,favicon)
    --页面开始加载事件
  end,
  onReceivedTitle=function(view,title)
    --获取到网页标题时加载的事件
    local uiManager=this.uiManager
    local toolbar=uiManager.toolbar
    --设置toolbar标题
    toolbar.titleText=title

  end,
  onLoadResource=function(view,url)
    --页面资源加载监听
    --可通过该方法获取网页上的资源
  end,
  onUrlLoad=function(view,url)
    --即将开始加载事件，url参数是即将加载的url
    --该函数返回一个布尔值
    --返回true则拦截本次加载
    return false
  end,
  onReceivedSslError=function(view, sslErrorHandler, sslError)
    --ssl证书错误处理事件
    --需自行处理，请返回true拦截原事件
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.Intent"
    import "android.net.Uri"
    local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(webView.getUrl()))
    activity.startActivity(viewIntent)
    print("证书错误,已复制本页面链接\n请自行处理")
    return true
  end
})

local uiManager=activity.getUiManager()
local webView=uiManager.getCurrentFragment().getWebView()

local WebChromeClient = luajava.bindClass "android.webkit.WebChromeClient"
webView.setWebChromeClient(luajava.override(WebChromeClient,{
  onShowFileChooser=function(a, view, valueCallback, fileChooserParams)
    --print(a, view, valueCallback, fileChooserParams)
    uploadFile=valueCallback
    local intent = fileChooserParams.createIntent()

    local MimeTypeMap = luajava.bindClass "android.webkit.MimeTypeMap"
    local mimeTypeMap = MimeTypeMap.getSingleton()
    if not mimeTypeMap.hasMimeType(intent.getType()) then
      intent.setType("*/*")
    end
  
    activity.startActivityForResult(intent, 1);
    return true;
  end,
  onProgressChanged=function(a,view,progress)
    view.parent.getChildAt(2).progress=progress
  end,
  onReceivedTitle=function(a,view,title)
    local uiManager=this.uiManager
    local toolbar=uiManager.toolbar
    --设置toolbar标题
    toolbar.titleText=title
    local cjson=require("cjson")
    local data=cjson.decode(this.getSharedData("History"))
    table.insert(data,1,{PageName=activity.getLoader().getPageName(),Title=title,Text=view.getUrl()})
    local json=cjson.encode(data)
    this.setSharedData("History",json)
  end,
}))

onActivityResult=function(req,res,intent)
  local Activity = luajava.bindClass "android.app.Activity"
  local Uri = luajava.bindClass "android.net.Uri"
  if (res == Activity.RESULT_CANCELED) then
    if(uploadFile~=nil )then
      uploadFile.onReceiveValue(nil);
    end
  end
  local results
  if (res == Activity.RESULT_OK)then
    if(uploadFile==nil or type(uploadFile)=="number")then
      return;
    end
    if (intent ~= nil) then
      local dataString = intent.getDataString();
      local clipData = intent.getClipData();
      if (clipData ~= nil) then
        results = Uri[clipData.getItemCount()];
        for i = 0,clipData.getItemCount()-1 do
          local item = clipData.getItemAt(i);
          results[i] = item.getUri();
        end
      end
      if (dataString ~= nil) then
        results = Uri[1];
        results[0]=Uri.parse(dataString)
      end
    end
  end
  if(results~=nil)then
    uploadFile.onReceiveValue(results);
    uploadFile = nil;
  end
end

local Context = luajava.bindClass "android.content.Context"
local Uri = luajava.bindClass "android.net.Uri"
import "android.app.DownloadManager"
import "android.webkit.DownloadListener"
function downloadFile(url,filepath,filename)
  downloadManager=activity.getSystemService(Context.DOWNLOAD_SERVICE);
  url=Uri.parse(url);
  print("已开始下载，请在通知栏查看进度\n存储在Download目录")
  request=DownloadManager.Request(url);
  request.setAllowedNetworkTypes(DownloadManager.Request.NETWORK_MOBILE|DownloadManager.Request.NETWORK_WIFI);
  request.setDestinationInExternalPublicDir(filepath,filename);
  request.setNotificationVisibility(DownloadManager.Request.VISIBILITY_VISIBLE_NOTIFY_COMPLETED);
  downloadManager.enqueue(request);
end
local uiManager=activity.getUiManager()
--获取当前页面的WebView
local webView=uiManager.getCurrentFragment().getWebView()

webView.setDownloadListener(DownloadListener{
  onDownloadStart=function(url,userAgent,contentDisposition,mimetype,contentLength)
    local filepath="/Download"--下载目录
    local URLUtil = luajava.bindClass "android.webkit.URLUtil"
    filename=URLUtil.guessFileName(url, contentDisposition, mimeType);
    --sock=require"socket.url"
    import "java.net.URLDecoder"
    local filename=URLDecoder.decode(filename)
    Dialog("下载文件","即将下载 "..filename.."\n链接:\n"..url,"复制链接","浏览器下载","直接下载",
    function()
      mBottomSheetDialog.dismiss()
      activity.getSystemService("clipboard").setText(url)
    end,
    function()
      mBottomSheetDialog.dismiss()
      import "android.content.Intent"
      import "android.net.Uri"
      local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(url))
      activity.startActivity(viewIntent)
    end,
    function()
      mBottomSheetDialog.dismiss()
      downloadFile(url,filepath,filename)
    end)
  end
})