--
-- @author 寒歌
-- @description Main是应用的主模块，其中注册了应用运行中UI事件的回调、Activity生命周期的回调等
-- 你也可以在此编写启动事件代码，或控制应用运行逻辑、自定义应用UI等等。
-- @other 本模版已为你编写好基础事件，建议在阅读注释并理解相关参数意义后再进行扩展编写
--

-- ****默认导入包****
require "import"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
-- ****不需要请删除****
import "android.webkit.CookieManager"
import "net.fusionapp.core.ui.fragment.WebInterface"
import "androidx.recyclerview.widget.*"
fragment=activity.uiManager.currentFragment
web=fragment.webView


package.path=package.path..";"..activity.loader.projectDir.toString().."/libs/?.lua";



-- @param data 侧滑栏列表的全部数据
-- @param recyclerView 侧滑栏列表控件
-- @param listIndex 点击的列表索引（点击的是第几个列表）
-- @param clickIndex 点击的项目索引（点击的第几个项目）
function onDrawerListItemClick(data, recyclerView, listIndex, itemIndex)
  --侧滑栏列表的数据是二维结构，所以需要先获取到点击项目所在列表的数据
  local listData = data.get(listIndex);
  --获取到所在列表的数据后获取点击项目的数据
  local itemData = listData.get(itemIndex);
  --最后获取到点击的项目的标题
  local itemTitle = itemData.getTitle();

  --TODO：
  print(itemTitle)
end

-- @param keyword 搜索栏输入的文本
-- @description 顶栏搜索功能回调事件
function onSearchEvent(keyword)
  --TODO：
  print("Search keyword:"..keyword)
end
import "Function_bottom"

if !activity.getSharedData("cookie") then
  cookie=nil
 else
  cookie=activity.getSharedData("cookie")
end
-- @param title 点击的菜单标题
-- @description 顶栏菜单项目点击回调事件
function onMenuItemClick(title)
  switch title

   case "退出"
    activity.finish()
   case "复制链接"
    --先导入包
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.*"
    activity.getSystemService(Context.CLIPBOARD_SERVICE).setText(webView.getUrl())
   case "浏览器打开"
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.Intent"
    import "android.net.Uri"
    local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(webView.getUrl()))
    activity.startActivity(viewIntent)
   case "原网页菜单"
    local uimanager=activity.uiManager
    local view=uimanager.currentFragment.getWebView()
    view.evaluateJavascript([[document.getElementsByClassName("comiis_share_key")[0].click();]],function end)
   case "分享网页"
    import "androidx.core.app.ShareCompat"
    ShareCompat.IntentBuilder
    .from(activity)
    .setText(web.getTitle().."\n"..web.getUrl())
    .setType("text/plain")
    .startChooser();
   case "添加收藏"
    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    import "android.content.res.ColorStateList"
    local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
    local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
    local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    local title=webView.getTitle()
    local view_table=
    {LinearLayout,
      layout_width="match",
      layout_height="match",
      orientation=1,
      {TextInputLayout,
        id="input_layout",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        layout_width="match",
        hint="标题",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text",
          text=title,
          layout_height="wrap",
          layout_width="match",
        },
      },
      {TextInputLayout,
        --id="input_layout",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        --suffixText="后缀文本",
        --error="错误提示",
        layout_width="match",
        hint="网址",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text2",
          text=webView.getUrl(),
          layout_height="wrap",
          layout_width="match",
        },
      },
    }

    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle("添加收藏")
    .setView(loadlayout(view_table))
    .setPositiveButton("确定",{
      onClick=function()
        local cjson=require("cjson")
        local data=cjson.decode(this.getSharedData("Collection"))
        table.insert(data,1,{PageName=activity.getLoader().getPageName(),Title=edit_text.text,Text=edit_text2.text})
        local json=cjson.encode(data)
        this.setSharedData("Collection",json)
        print("添加成功")
      end
    })
    .setNegativeButton("取消",nil)
    .show()

    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)

   case "网页查找"
    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    import "android.content.res.ColorStateList"
    local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
    local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
    local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"

    local view_table=
    {LinearLayout,
      layout_width="match",
      layout_height="match",
      orientation=1,
      {TextInputLayout,
        id="input_layout",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        layout_width="match",
        hint="内容",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text",
          text=this.getSharedData("lookup"),
          layout_height="wrap",
          layout_width="match",
        },
      },

    }
    local function onSearchEvent(input)
      if input then
        web.findAllAsync(input)
       else
        web.findNext(true)
      end
      this.setSharedData("lookup",input)
      return true
    end

    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle("网页查找")
    .setView(loadlayout(view_table))
    .setPositiveButton("下一个",nil)
    .setNegativeButton("取消",{
      onClick=function()
        web.clearMatches()
      end
    })
    .show()
    dialog.getButton(AlertDialog.BUTTON1).onClick=function()
      onSearchEvent(edit_text.text)
    end
    local lp =dialog.getWindow().getAttributes()
    lp.alpha = 0.6
    dialog.getWindow().setAttributes(lp)
    --local ColorDrawable = luajava.bindClass "android.graphics.drawable.ColorDrawable"
    --dialog.getWindow().setBackgroundDrawable(ColorDrawable());
    local lp = dialog.getWindow().getAttributes();
    lp.dimAmount=0.0
    dialog.getWindow().setAttributes(lp);
    dialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
   case "电脑版"
    local bundle=Bundle()
    bundle.putString("url",web.getUrl())
    --bundle.putInt("key",0)
    activity.startFusionActivity("Computerversion",bundle)
  end
end

function dp2px(dpValue)
  local scale = activity.getResources().getDisplayMetrics().scaledDensity
  return dpValue * scale + 0.5
end

import "com.google.android.material.card.MaterialCardView"
import "com.google.android.material.bottomsheet.BottomSheetDialog"
import "android.content.res.ColorStateList"
import "android.graphics.drawable.GradientDrawable"

local BottomSheetDialogdrawable = GradientDrawable()
BottomSheetDialogdrawable.setShape(GradientDrawable.RECTANGLE)
BottomSheetDialogdrawable.setColor(0xffffffff)
BottomSheetDialogdrawable.setCornerRadii({dp2px(8),dp2px(8),dp2px(8),dp2px(8),0,0,0,0});


if activity.getPackageName()=="net.fusionapp" then
  R=luajava.bindClass "net.fusionapp.R"
 else
  R=luajava.bindClass "net.fusionapp.core.R"
end

function Ripple(view,color)
  import "android.content.res.ColorStateList"
  local attrsArray = {android.R.attr.selectableItemBackgroundBorderless}
  local typedArray =activity.obtainStyledAttributes(attrsArray)
  local ripple=typedArray.getResourceId(0,0)
  local Pretend=activity.Resources.getDrawable(ripple)
  Pretend.setColor(ColorStateList(int[0].class{int{}},int{color}))
  return Pretend.setColor(ColorStateList(int[0].class{int{}},int{color}))
end
local uiManager=this.uiManager
local colors=uiManager.getColors()
colorPrimary=colors.colorPrimary--主色
colorTextPrimary=colors.textColorPrimary--主文本色
colorBackground=colors.windowBackground--窗体背景色

function Dialog(title,content,mButton1,mButton2,mButton3,mButton1_,mButton2_,mButton3_)
  import "com.google.android.material.bottomsheet.BottomSheetDialog"
  mBottomSheetDialog=BottomSheetDialog(activity);
  mBottomSheetDialog.setContentView(loadlayout({
    LinearLayout;
    layout_height="match_parent";
    BackgroundDrawable=BottomSheetDialogDrawable;
    layout_width="match_parent";
    orientation="vertical";
    {
      LinearLayout;
      layout_marginTop="5dp";
      layout_width="-1";
      gravity="center";
      -- BackgroundColor="#FFFFFFFF";
      {
        MaterialCardView;
        layout_height="8dp";
        CardElevation="0dp";
        radius="4dp";
        layout_margin="5dp";
        layout_width="75dp";
        CardBackgroundColor="#FFF4F5F7";
      };
    };
    {
      TextView;
      layout_width="-1";
      layout_height="-2";
      textSize="20sp";
      layout_marginTop="9dp";
      layout_marginLeft="24dp";
      layout_marginRight="24dp";
      layout_marginBottom="0dp";
      Text=title;
      textStyle="bold";
      textColor=colorTextPrimary;
    };
    {
      ScrollView;
      layout_width="match_parent";
      layout_height="-2";
      layout_weight=100;
      {
        TextView;
        id="_view";
        textIsSelectable=true;
        text=content;
        paddingTop="8dp";
        paddingBottom="8dp";
        paddingRight="24dp";
        paddingLeft="24dp";
        layout_width="match_parent";
      };
    };
    {
      LinearLayout;
      layout_height="-2";
      layout_weight=1;
      layout_width="match_parent";
      orientation="vertical";
      {
        MaterialCardView;
        layout_weight=1;
        layout_height="50dp";
        CardElevation="3dp";
        radius="25dp";
        layout_marginTop="10dp";
        layout_marginRight="20dp";
        layout_marginLeft="20dp";
        layout_width="-1";
        CardBackgroundColor=0xff0984fd;
        onClick=mButton3_;
        {
          LinearLayout;
          layout_height="match_parent";
          gravity="center";
          layout_width="match_parent";
          focusable="true";
          {
            TextView;
            textStyle="bold";
            Text=mButton3;
            textColor=0xFFFFFFFF;
            textSize="15sp";
          };
        };
      };
      {
        LinearLayout;
        layout_height="-2";
        layout_width="match_parent";
        orientation="horizontal";
        {
          MaterialCardView;
          layout_weight=1;
          layout_height="50dp";
          CardElevation="3dp";
          radius="25dp";
          layout_marginTop="20dp";
          layout_marginRight="10dp";
          layout_marginLeft="20dp";
          layout_marginBottom="20dp";
          layout_width="-1";
          CardBackgroundColor=colorPrimary;
          onClick=mButton1_;
          {
            LinearLayout;
            layout_height="match_parent";
            gravity="center";
            layout_width="match_parent";
            focusable="true";
            {
              TextView;
              textStyle="bold";
              Text=mButton1;
              textColor=colorTextPrimary;
              textSize="15sp";
            };
          };
        };
        {
          MaterialCardView;
          layout_weight=1;
          layout_height="50dp";
          CardElevation="3dp";
          radius="25dp";
          layout_marginTop="20dp";
          layout_marginRight="20dp";
          layout_marginLeft="10dp";
          layout_marginBottom="20dp";
          layout_width="-1";
          CardBackgroundColor=colorPrimary;
          onClick=mButton2_;
          {
            LinearLayout;
            layout_height="match_parent";
            gravity="center";
            layout_width="match_parent";
            focusable="true";
            {
              TextView;
              textStyle="bold";
              Text=mButton2;
              textColor=colorTextPrimary;
              textSize="15sp";
            };
          };
        };
      };
    };
  })).getWindow().setDimAmount(0.5);
  if Build.VERSION.SDK_INT >= 21 then
    mBottomSheetDialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS);
  end
  mBottomSheetDialog.getWindow().findViewById(R.id.design_bottom_sheet).setBackgroundResource(android.R.color.transparent);
  mBottomSheetDialog.show();
  if content==nil then
    _view.setVisibility(View.GONE)
  end
end

function 获取浏览页(n)
  if n then
    return activity.uiManager.getPage(n)
   else
    return activity.uiManager.currentPage
  end
end

function 获取浏览器()
  return 获取浏览页().webView
end
function 加载Js(str,callback)
  if not pcall(function()
      获取浏览器().evaluateJavascript(str,callback or function() end)
    end) then
    获取浏览器().loadUrl("javascript:"..str)
  end
end
function 点击元素(Class名, 索引)
  if 索引 then
    加载Js("var element=document.getElementsByClassName(" .. Class名 .. ")[" .. 索引 .. "] if(typeof(element.onclick)=='undefined'){element.click()}else{element.onclick()}")
   else
    加载Js("var element=document.getElementsByClassName(" .. Class名 .. ")[0] if(typeof(element.onclick)=='undefined'){element.click()}else{element.onclick()}")
  end
end
--悬浮按钮点击事件
function onFloatingActionButtonClick(v)
  activity.uiManager.currentFragment.webView.reload()
end
function copy(text)
  activity.getSystemService("clipboard").text=text
end
local intent=activity.getIntent()
local uiManager=activity.getUiManager()
--获取当前页面的WebView
local webView=uiManager.getCurrentFragment().getWebView()
webView.loadUrl(intent.getStringExtra("url") or "https://ysqbbs.com/thread-132065-1-1.html")
function Login()
  activity.startFusionActivity("login")
end
local uimanager=activity.uiManager
local fragment=uimanager.currentFragment.getWebView()
import "android.webkit.WebViewClient"
fragment.setWebViewClient(luajava.override(WebViewClient,{
  onReceivedError=function(_,view,webResourceRequest,webResourceError)
    --连接错误事件
  end,

  onPageFinished=function(_,view,url)
    --页面加载结束事件
    加载Js([[document.getElementsByClassName("comiis_lookfulltext_key")[0].click();]])
    加载Js([[
    document.getElementsByClassName("header_z")[1].setAttribute("onclick","JsHD_djsj_51754();"+document.getElementsByClassName("header_z")[1].getAttribute("onclick"));function JsHD_djsj_51754() {alert("关闭了回复");};
    document.getElementById("fastpostsubmit").setAttribute("onclick","JsHD_djsj_51754();"+document.getElementById("fastpostsubmit").getAttribute("onclick"));
    ]])
    if this.getSharedData("显示FPS")=="true" then
      view.evaluateJavascript("Display_fps();",function end)
    end
    if this.getSharedData("URL超连接")=="true" then
      加载Js([[url_clickable();]])
    end
    加载Js([[var obj=document.getElementsByClassName("f_d")[0];
    var obj2=document.getElementsByClassName("kmtit")[0];
    var patt = /#/;
     if (!patt.test(obj.innerHTML)) {
    obj.innerHTML=obj.innerHTML+'&nbsp;#<a href="'+obj2.attributes["href"].nodeValue+'">'+obj2.innerHTML+'</a>';
    }]])
  
    if this.getSharedData("自动上下页")=="true" then
      加载Js([[automatic_page_down();]])
    end


  end,
  shouldOverrideUrlLoading=function(_,view,webResourceRequest,a)
    -- print()
    local url=tostring(webResourceRequest.getUrl())
    local packageName=url:match'ysqbbs%.com/member%.php%?mod=logging&action=login'
    local packageName5=url:match'ysqbbs%.com'
    local packageName6=url:match'ysqbbs%.com/home.php%?mod=space&uid=.+&do=profile'
    local packageName7=url:match'ysqbbs%.com/member.php%?mod=register213&mobile=2'
    local packageName17=url:match'ysqbbs%.com/forum%.php%?mod=forumdisplay'
    local packageName19=url:match'ysqbbs%.com/forum%-.+%-.+%.html'
    local packageName18=url:match'ysqbbs%.com/group%.php%?mod=index.+'
    local packageName13=url:match'ysqbbs%.com/page%-2%.html'
    local packageName22=url:match'ysqbbs%.com/space%-uid%-.+%.html'
    local packageName23=url:match'ysqbbs%.com/forum%.php%?mod=misc%&action=showdarkroom'
    local packageName24=url:match'ysqbbs%.com/thread%-.+%-.+%-.+%.html'
    local packageName26=url:match'ysqbbs%.com/forum%.php%?mobile=no'
    if !packageName5 then
      --local url = string.match(url,"(.+)%%C2%%A0%%C2%%A0$") or url
      Dialog("即将离开本站","您即将离开Mt论坛，请注意您的帐号和财产安全。\n\n"..url,"复制链接","浏览器打开","继续访问",
      function()
        mBottomSheetDialog.dismiss()
        activity.getSystemService("clipboard").setText(url)
      end,
      function()
        mBottomSheetDialog.dismiss()
        import "android.content.Intent"
        import "android.net.Uri"
        local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(url))
        activity.startActivity(viewIntent)
      end,
      function()
        mBottomSheetDialog.dismiss()
        local bundle=Bundle()
        bundle.putString("url",url)
        --bundle.putInt("key",0)
        activity.startFusionActivity("Browsepage",bundle)
      end)
      return true
     elseif packageName or packageName7 then
      Login()
      return true
     elseif packageName6 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
      return true
     elseif packageName17 or packageName19 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Plate",bundle)
      return true
     elseif packageName18 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Circle",bundle)
      return true
     elseif packageName13 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Notopnolow",bundle)
      return true
     elseif packageName22 then
      local uid=url:match('uid%-(.+)%.html')
      --print("https://avatar-bbs.mt2.cn/uc_server/avatar.php?uid="..uid.."&size=middle")
      local bundle=Bundle()
      bundle.putString("url","https://ysqbbs.com/home.php?mod=space&uid="..uid.."&do=profile")
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
      return true
     elseif packageName23 then
      activity.startFusionActivity("Xiaoheiwu")
      return true
     elseif packageName26 then
      activity.startFusionActivity("Computerversion")
      return true
     else
      --print(url:match'ysqbbs%.com/thread%-(.+%-.+%-.+)%.html')
      --print(web.getUrl():match'ysqbbs%.com/thread%-(.+%-.+%-.+)%.html')
      if packageName24 then
        if this.getSharedData("下一页重调用")=="true" then
          if (url:match'ysqbbs%.com/thread%-(.+%-.+%-.+)%.html') ~= (web.getUrl():match'ysqbbs%.com/thread%-(.+%-.+%-.+)%.html') then
            local bundle=Bundle()
            bundle.putString("url",url)
            --bundle.putInt("key",0)
            activity.startFusionActivity("Detailsofthepost",bundle)
            return true
           else
            return false
          end
         else
          if url:match'ysqbbs%.com/thread%-(.+)%-.+%-.+%.html' ~= web.getUrl():match'ysqbbs%.com/thread%-(.+)%-.+%-.+%.html' then
            local bundle=Bundle()
            bundle.putString("url",url)
            --bundle.putInt("key",0)
            activity.startFusionActivity("Detailsofthepost",bundle)
            return true
           else
            return false
          end
        end
       else
        return false
      end
    end
  end,
  onPageStarted=function(_,view,url,bitmap)
  --[=[  view.evaluateJavascript([[// ==UserScript==
// @name         MT论坛-无油猴版
// @namespace    http://tampermonkey.net/
// @description  MT论坛效果增强，如自动签到、自动展开帖子、滚动加载评论、显示uid、屏蔽用户、手机版小黑屋、编辑器优化等
// @version      0.1
// @author       WhiteSevs
// @match        *://ysqbbs.com/*
// @license      GPL-3.0-only
// @grant        none
// @run-at       document-start
// ==/UserScript==

(function() {
    'use strict';
    window.tampermonkeyByMT = `
    (function() {
        'use strict';
        const JSResource = ["https://lf26-cdn-tos.bytecdntp.com/cdn/expire-1-M/jquery/3.4.1/jquery.min.js",
                            "https://greasyfork.org/scripts/449562-nzmsgbox/code/NZMsgBox.js", 
                            "https://unpkg.com/any-touch/dist/any-touch.umd.min.js", 
                            "https://greasyfork.org/scripts/449471-viewer/code/Viewer.js",
                            "https://greasyfork.org/scripts/449512-xtiper/code/Xtiper.js",
                            "https://greasyfork.org/scripts/452322-js-watermark/code/js-watermark.js",
                            "https://greasyfork.org/scripts/455186-whitesevsutils/code/WhiteSevsUtils.js"];

        const url = "https://greasyfork.org/scripts/401359-mt%E8%AE%BA%E5%9D%9B/code/MT%E8%AE%BA%E5%9D%9B.user.js";

        function loadJS(url){
            return new Promise( (res) => {
                let tempNode = document.createElement("script");
                tempNode.setAttribute("src", url);
                document.head.append(tempNode);
                tempNode.onload = () => {
                    res();
                }
            })
        }
        async function asyncLoadAllScript() {
            for(var item of JSResource){
                console.log("引入js: "+item);
                await loadJS(item);
                console.log("完毕");
            }
            console.log("引入油猴主js: "+url);
            loadJS(url);
            console.log("完毕");
        }
        asyncLoadAllScript();
    })();`;
    let tempNode = document.createElement("script");
    tempNode.innerHTML = window.tampermonkeyByMT;
    document.head.append(tempNode);
})();]],function end)]=]
    --页面开始加载
    local packageName4=url:match'ysqbbs%.com/thread%-.-%-.+'
    local packageName10=url:match'ysqbbs%.com/forum.php%?mod=viewthread&tid=.+'

    if packageName4 or packageName10 then
      bottom.setVisibility(this.uiManager.viewPager.GONE)
      this.uiManager.getFloatingActionButton().setVisibility(this.uiManager.viewPager.VISIBLE)
    end
  end,

}))
function Load_next_page(url)
  if url then
    Http.get(url,cookie,"utf-8",nil,function(code,content,cookie,header)
      if code==200 then
        local content=content:match'<div class="comiis_bodybox">(.+)<div class="bg_e b_t cl">' or content
        local content=content:match[[</script>
                                                       (.+)<div class="comiis_fastpostbox comiis_showleftbox bg_e">]] or content
        -- print(content)
        ---content="55566"
        加载Js([[Write_html(`]]..content..'`);')
       else
      end
    end)
  end
end
local uiManager=activity.getUiManager()
local webView=uiManager.getCurrentFragment().getWebView()

local WebChromeClient = luajava.bindClass "android.webkit.WebChromeClient"
webView.setWebChromeClient(luajava.override(WebChromeClient,{
  onShowFileChooser=function(a, view, valueCallback, fileChooserParams)
    --print(a, view, valueCallback, fileChooserParams)
    uploadFile=valueCallback
    local intent = fileChooserParams.createIntent()
    
    local MimeTypeMap = luajava.bindClass "android.webkit.MimeTypeMap"
    local mimeTypeMap = MimeTypeMap.getSingleton()
    if not mimeTypeMap.hasMimeType(intent.getType()) then
      intent.setType("*/*")
    end
  
    activity.startActivityForResult(intent, 1);
    return true;
  end,
  onProgressChanged=function(a,view,progress)
    view.parent.getChildAt(2).progress=progress
  end,
  onReceivedTitle=function(a,view,title)
    local uiManager=this.uiManager
    local toolbar=uiManager.toolbar
    --设置toolbar标题
    toolbar.titleText=title
    local cjson=require("cjson")
    local data=cjson.decode(this.getSharedData("History"))
    table.insert(data,1,{PageName=activity.getLoader().getPageName(),Title=title,Text=view.getUrl()})
    local json=cjson.encode(data)
    this.setSharedData("History",json)
  end,
  onJsAlert=function(a,view,url,message,result)
    if message=="点击了回复" then
      result.cancel()
      this.uiManager.getFloatingActionButton().setVisibility(this.uiManager.viewPager.GONE)
      bottom.setVisibility(this.uiManager.viewPager.VISIBLE)
      return true
     elseif message=="关闭了回复" then
      result.cancel()
      bottom.setVisibility(this.uiManager.viewPager.GONE)
      this.uiManager.getFloatingActionButton().setVisibility(this.uiManager.viewPager.VISIBLE)
      return true
     elseif message:match'下一页：(.-)' then
      result.cancel()
      Load_next_page(message:match'下一页：(.+)')
      return true
    end
  end,
  onShowCustomView=function(a,view,callback)
    --重写WebChromeClient必须重写这个方法，否则影响视频全屏
    --视频全屏操作会执行这个方法，想要自己做全屏的可以在这里处理
    --callback对象是WebChromeClient.CustomViewCallback
    -- print("视频全屏")
    --保存view供之后退出全屏时移除
    customView = view
    --覆盖在根布局上面
    webView.getRootView().addView(view)
  end,
  onHideCustomView=function(a)
    --视频退出全屏触发的方法，重写onShowCustomView必须同时重写这个方法
    --print("退出全屏")
    --移除view
    customView.getParent().removeView(customView)
    --变量置空
    customView = nil
  end
}))

onActivityResult=function(req,res,intent)
  local Activity = luajava.bindClass "android.app.Activity"
  local Uri = luajava.bindClass "android.net.Uri"
  if (res == Activity.RESULT_CANCELED) then
    if(uploadFile~=nil )then
      uploadFile.onReceiveValue(nil);
    end
  end
  local results
  if (res == Activity.RESULT_OK)then
    if(uploadFile==nil or type(uploadFile)=="number")then
      return;
    end
    if (intent ~= nil) then
      local dataString = intent.getDataString();
      local clipData = intent.getClipData();
      if (clipData ~= nil) then
        results = Uri[clipData.getItemCount()];
        for i = 0,clipData.getItemCount()-1 do
          local item = clipData.getItemAt(i);
          results[i] = item.getUri();
        end
      end
      if (dataString ~= nil) then
        results = Uri[1];
        results[0]=Uri.parse(dataString)
      end
    end
  end
  if(results~=nil)then
    uploadFile.onReceiveValue(results);
    uploadFile = nil;
  end
end

local Context = luajava.bindClass "android.content.Context"
import "android.app.DownloadManager"
import "android.webkit.DownloadListener"
import "android.net.Uri"
function downloadFile(url,filepath,filename)
  downloadManager=activity.getSystemService(Context.DOWNLOAD_SERVICE);
  url=Uri.parse(url);
  print("已开始下载，请在通知栏查看进度\n存储在Download目录")
  request=DownloadManager.Request(url);
  request.setAllowedNetworkTypes(DownloadManager.Request.NETWORK_MOBILE|DownloadManager.Request.NETWORK_WIFI);
  request.setDestinationInExternalPublicDir(filepath,filename);
  request.setNotificationVisibility(DownloadManager.Request.VISIBILITY_VISIBLE_NOTIFY_COMPLETED);
  downloadManager.enqueue(request);
end
local uiManager=activity.getUiManager()
--获取当前页面的WebView
local webView=uiManager.getCurrentFragment().getWebView()

webView.setDownloadListener(DownloadListener{
  onDownloadStart=function(url,userAgent,contentDisposition,mimetype,contentLength)
    local filepath="/Download"--下载目录
    local URLUtil = luajava.bindClass "android.webkit.URLUtil"
    filename=URLUtil.guessFileName(url, contentDisposition, mimeType);
    --sock=require"socket.url"
    import "java.net.URLDecoder"
    local filename=URLDecoder.decode(filename)
    Dialog("下载文件","即将下载 "..filename.."\n链接:\n"..url,"复制链接","浏览器下载","直接下载",
    function()
      mBottomSheetDialog.dismiss()
      activity.getSystemService("clipboard").setText(url)
    end,
    function()
      mBottomSheetDialog.dismiss()
      import "android.content.Intent"
      import "android.net.Uri"
      local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(url))
      activity.startActivity(viewIntent)
    end,
    function()
      mBottomSheetDialog.dismiss()
      downloadFile(url,filepath,filename)
    end)
  end
})

