--
-- @author 寒歌
-- @description Main是应用的主模块，其中注册了应用运行中UI事件的回调、Activity生命周期的回调等
-- 你也可以在此编写启动事件代码，或控制应用运行逻辑、自定义应用UI等等。
-- @other 本模版已为你编写好基础事件，建议在阅读注释并理解相关参数意义后再进行扩展编写
--

-- ****默认导入包****
require "import"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
-- ****不需要请删除****
import "android.webkit.CookieManager"
import "net.fusionapp.core.ui.fragment.WebInterface"
import "androidx.recyclerview.widget.*"
fragment=activity.uiManager.currentFragment
web=fragment.webView

package.path=package.path..";"..activity.loader.projectDir.toString().."/libs/?.lua";

-- @param data 侧滑栏列表的全部数据
-- @param recyclerView 侧滑栏列表控件
-- @param listIndex 点击的列表索引（点击的是第几个列表）
-- @param clickIndex 点击的项目索引（点击的第几个项目）
function onDrawerListItemClick(data, recyclerView, listIndex, itemIndex)
  --侧滑栏列表的数据是二维结构，所以需要先获取到点击项目所在列表的数据
  local listData = data.get(listIndex);
  --获取到所在列表的数据后获取点击项目的数据
  local itemData = listData.get(itemIndex);
  --最后获取到点击的项目的标题
  local itemTitle = itemData.getTitle();

  --TODO：
  print(itemTitle)
end

-- @param keyword 搜索栏输入的文本
-- @description 顶栏搜索功能回调事件
function onSearchEvent(keyword)
  local bundle=Bundle().putString("keyword",keyword)
  activity.startFusionActivity("search",bundle)
end
if activity.getPackageName()=="net.fusionapp" then
  R=luajava.bindClass "net.fusionapp.R"
 else
  R=luajava.bindClass "net.fusionapp.core.R"
end
import "Function_bottom"

-- @param title 点击的菜单标题
-- @description 顶栏菜单项目点击回调事件
function onMenuItemClick(title)
  switch title
   case "分享网页"
    import "androidx.core.app.ShareCompat"
    ShareCompat.IntentBuilder
    .from(activity)
    .setText(activity.uiManager.currentFragment.getWebView().getTitle().."\n"..activity.uiManager.currentFragment.getWebView().getUrl())
    .setType("text/plain")
    .startChooser();
   case "退出"
    activity.finish()
   case "复制链接"
    --先导入包
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.*"
    activity.getSystemService(Context.CLIPBOARD_SERVICE).setText(webView.getUrl())
   case "浏览器打开"
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.Intent"
    import "android.net.Uri"
    local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(webView.getUrl()))
    activity.startActivity(viewIntent)
   case "刷新"
    web.reload()
   case "高级筛选"
    web.evaluateJavascript([[document.getElementsByClassName("comiis_font kmxiao")[0].click();]],function end)
   case "网页查找"
    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    import "android.content.res.ColorStateList"
    local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
    local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
    local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"

    local view_table=
    {LinearLayout,
      layout_width="match",
      layout_height="match",
      orientation=1,
      {TextInputLayout,
        id="input_layout",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        layout_width="match",
        hint="内容",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text",
          text=this.getSharedData("lookup"),
          layout_height="wrap",
          layout_width="match",
        },
      },

    }
    local function onSearchEvent(input)
      if input then
        web.findAllAsync(input)
       else
        web.findNext(true)
      end
      this.setSharedData("lookup",input)
      return true
    end

    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle("网页查找")
    .setView(loadlayout(view_table))
    .setPositiveButton("下一个",nil)
    .setNegativeButton("取消",{
      onClick=function()
        web.clearMatches()
      end
    })
    .show()
    dialog.getButton(AlertDialog.BUTTON1).onClick=function()
      onSearchEvent(edit_text.text)
    end
    local lp =dialog.getWindow().getAttributes()
    lp.alpha = 0.6
    dialog.getWindow().setAttributes(lp)
    --local ColorDrawable = luajava.bindClass "android.graphics.drawable.ColorDrawable"
    --dialog.getWindow().setBackgroundDrawable(ColorDrawable());
    local lp = dialog.getWindow().getAttributes();
    lp.dimAmount=0.0
    dialog.getWindow().setAttributes(lp);
    dialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(Color.parseColor(colorAccent)).setRippleColor(colorRipple)

  end
end

function 获取浏览页(n)
  if n then
    return activity.uiManager.getPage(n)
   else
    return activity.uiManager.currentPage
  end
end

function 获取浏览器()
  return 获取浏览页().webView
end
function 加载Js(str,callback)
  if not pcall(function()
      获取浏览器().evaluateJavascript(str,callback or function() end)
    end) then
    获取浏览器().loadUrl("javascript:"..str)
  end
end
function 点击元素(Class名, 索引)
  if 索引 then
    加载Js("var element=document.getElementsByClassName(" .. Class名 .. ")[" .. 索引 .. "] if(typeof(element.onclick)=='undefined'){element.click()}else{element.onclick()}")
   else
    加载Js("var element=document.getElementsByClassName(" .. Class名 .. ")[0] if(typeof(element.onclick)=='undefined'){element.click()}else{element.onclick()}")
  end
end
--悬浮按钮点击事件
function onFloatingActionButtonClick(v)
  web.evaluateJavascript([[document.querySelector("div.header_y .comiis_font").click();]],function end)
end

local intent=activity.getIntent()
local uiManager=activity.getUiManager()
--获取当前页面的WebView
local webView=uiManager.getCurrentFragment().getWebView()
webView.loadUrl(intent.getStringExtra("url"))
function Login()
  activity.startFusionActivity("login")
end
local uimanager=activity.uiManager
local fragment=uimanager.currentFragment.getWebView()
import "android.webkit.WebViewClient"
fragment.setWebViewClient(luajava.override(WebViewClient,{
  shouldOverrideUrlLoading=function(_,view,webResourceRequest)
    local url=tostring(webResourceRequest.getUrl())
    local packageName=url:match'ysqbbs%.com/member%.php%?mod=logging&action=login'
    local packageName3=url:match'ysqbbs%.com/search%.php%?mod=forum&mobile=2'
    local packageName4=url:match'ysqbbs%.com/thread%-.+%-.+%-.+%.html'
    local packageName6=url:match'ysqbbs%.com/home.php%?mod=space&uid=.+&do=profile'

    if packageName then
      Login()
      return true
     elseif packageName3 then
      print("为了更好的体验，请点击上方搜索")
      return true
     elseif packageName4 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Detailsofthepost",bundle)
      return true
     elseif packageName6 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
      return true
     else
      return false
    end
  end,
  onPageFinished=function(_,view,url)
    --页面加载结束事件
    function getBitmapFromView(v)
      local Bitmap = luajava.bindClass "android.graphics.Bitmap"
      local Canvas = luajava.bindClass "android.graphics.Canvas"
      local Color = luajava.bindClass "android.graphics.Color"
      local b = Bitmap.createBitmap(v.getWidth(), v.getHeight(), Bitmap.Config.RGB_565);
      local c = Canvas(b);
      v.layout(v.getLeft(), v.getTop(), v.getRight(), v.getBottom());
      local bgDrawable = v.getBackground();
      if (bgDrawable ~= null) then
        bgDrawable.draw(c);
       else
        c.drawColor(Color.WHITE);
        v.draw(c);
      end
      return b;
    end
    local Color = luajava.bindClass "android.graphics.Color"
    local bitmap = getBitmapFromView(view)
    local color=bitmap.getPixel(1,1)
    import "android.graphics.drawable.ColorDrawable"
    this.uiManager.appBarLayout.setBackgroundDrawable(ColorDrawable(color))
    activity.window.statusBarColor=color
    bitmap.recycle()
    if this.getSharedData("显示FPS")=="true" then
      view.evaluateJavascript("Display_fps();",function end)
    end

  end,
  onPageStarted=function(_,view,url,bitmap)
    --页面开始加载
    local packageName3=url:match'ysqbbs%.com/forum.+'
    if packageName3 then
      bottom.setVisibility(this.uiManager.viewPager.GONE)
      this.uiManager.getFloatingActionButton().setVisibility(this.uiManager.viewPager.VISIBLE)
    end
  end,

}))

local uiManager=activity.getUiManager()
local webView=uiManager.getCurrentFragment().getWebView()

local WebChromeClient = luajava.bindClass "android.webkit.WebChromeClient"
webView.setWebChromeClient(luajava.override(WebChromeClient,{
  onShowFileChooser=function(a, view, valueCallback, fileChooserParams)
    --print(a, view, valueCallback, fileChooserParams)
    uploadFile=valueCallback
    local intent = fileChooserParams.createIntent()
    local MimeTypeMap = luajava.bindClass "android.webkit.MimeTypeMap"
    local mimeTypeMap = MimeTypeMap.getSingleton()
    if not mimeTypeMap.hasMimeType(intent.getType()) then
      intent.setType("*/*")
    end
    activity.startActivityForResult(intent, 1);
    return true;
  end,
  onProgressChanged=function(a,view,progress)
    view.parent.getChildAt(2).progress=progress
  end,
  onReceivedTitle=function(a,view,title)
    local uiManager=this.uiManager
    local toolbar=uiManager.toolbar
    --设置toolbar标题
    toolbar.titleText=title
    local cjson=require("cjson")
    local data=cjson.decode(this.getSharedData("History"))
    table.insert(data,1,{PageName=activity.getLoader().getPageName(),Title=title,Text=view.getUrl()})
    local json=cjson.encode(data)
    this.setSharedData("History",json)
  end,
  onJsAlert=function(a,view,url,message,result)
    if message=="点击了回复" then
      result.cancel()
      this.uiManager.getFloatingActionButton().setVisibility(this.uiManager.viewPager.GONE)
      bottom.setVisibility(this.uiManager.viewPager.VISIBLE)
      return true
     elseif message=="关闭了回复" then
      result.cancel()
      bottom.setVisibility(this.uiManager.viewPager.GONE)
      this.uiManager.getFloatingActionButton().setVisibility(this.uiManager.viewPager.VISIBLE)
      return true
    end
  end,
}))

onActivityResult=function(req,res,intent)
  local Activity = luajava.bindClass "android.app.Activity"
  local Uri = luajava.bindClass "android.net.Uri"
  if (res == Activity.RESULT_CANCELED) then
    if(uploadFile~=nil )then
      uploadFile.onReceiveValue(nil);
    end
  end
  local results
  if (res == Activity.RESULT_OK)then
    if(uploadFile==nil or type(uploadFile)=="number")then
      return;
    end
    if (intent ~= nil) then
      local dataString = intent.getDataString();
      local clipData = intent.getClipData();
      if (clipData ~= nil) then
        results = Uri[clipData.getItemCount()];
        for i = 0,clipData.getItemCount()-1 do
          local item = clipData.getItemAt(i);
          results[i] = item.getUri();
        end
      end
      if (dataString ~= nil) then
        results = Uri[1];
        results[0]=Uri.parse(dataString)
      end
    end
  end
  if(results~=nil)then
    uploadFile.onReceiveValue(results);
    uploadFile = nil;
  end
end


