--[[
 @author jies辰
 @description 应用缓存清理
]]

-- ****导入****
require "import"
import "android.os.*"
import "android.widget.*"
import "android.view.*"

--uiManager
uiManager=activity.getUiManager()




--配色
import "android.graphics.Color"
local colors=uiManager.getColors()
colorPrimary=Color.parseColor(colors.colorPrimary)
colorAccent=Color.parseColor(colors.colorAccent)
colorTextPrimary=Color.parseColor(colors.textColorPrimary)
colorTextSecondary=Color.parseColor(colors.textColorSecondary)
colorBackground=Color.parseColor(colors.windowBackground)
import "android.content.res.ColorStateList"
import "com.google.android.material.card.MaterialCardView"
import "com.google.android.material.button.MaterialButton"
import "androidx.recyclerview.widget.RecyclerView"
--加载layout
list=ArrayList()
list.add(loadlayout("layout"))
import "net.fusionapp.core.ui.adapter.BasePagerAdapter"
uiManager.viewPager.setAdapter(BasePagerAdapter(list))

--杂项样式
local window=activity.getWindow()
window.addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS).addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_NAVIGATION)
--设置导航栏状态栏沉浸
window.getAttributes().layoutInDisplayCutoutMode=1
--去横屏黑条
appBar=uiManager.appBarLayout
toolbar=uiManager.toolbar
--调整状态栏导航栏沉浸后的顶栏
appBar.setPadding(0,0,0,0)
toolbar.setPadding(0,95,0,0)


list_layout={MaterialCardView,
  layout_height="wrap",
  layout_width="match",
  elevation=0,
  radius=0,
  cardBackgroundColor=colorPrimary,
  id="card",
  {CheckBox,
    layout_margin="13dp",
    layout_marginLeft="15dp",
    layout_marginRight="23dp",
    paddingLeft="7dp",
    textSize="17sp",
    textColor=colorTextPrimary,
    id="check",
  },
}
--设置适配器
import "androidx.recyclerview.widget.LinearLayoutManager"
recycler.layoutManager=LinearLayoutManager(activity)
list_adapter=LuaRecyclerAdapter(activity,list_layout).setClickViewId("card")
recycler.setAdapter(list_adapter)

ExternalFilesDir=activity.getExternalFilesDir(nil).toString()
DataDir=activity.getDataDir().toString()
CacheData={
  {text="应用崩溃记录",
    dir=ExternalFilesDir.."/crash"},
  {text="图片加载缓存",
    dir=DataDir.."/cache/image_manager_disk_cache"},
  {text="WebView 存储数据",
    dir=DataDir.."/app_webview"},
  {text="WebView 缓存信息",
    dir=DataDir.."/cache/WebView"},
  {text="下载的文件",
    dir=DataDir.."/cache/download"},
}

import"java.io.File"
function GetDirSize(dir)
  size=0
  local listFile=File(dir).listFiles()
  if listFile
    for i,child in ipairs(luajava.astable(listFile))
      if child.isDirectory()
        size=size+GetDirSize(child.toString())
       else
        size=size+child.length()
      end
    end
  end
  return size
end

import "android.text.format.Formatter"
function UpdateCacheList()
  list_adapter.clear()
  for i,value in ipairs(CacheData)
    list_adapter.add{check=value.text.." ("..Formatter.formatFileSize(activity,GetDirSize(value.dir))..")"}
  end
end
UpdateCacheList()

function DeleteDir(dir)
  local file=File(dir)
  local listFile=file.listFiles()
  if listFile
    for i,child in ipairs(luajava.astable(listFile))
      if child.isDirectory()
        DeleteDir(child.toString())
       else
        child.delete()
      end
    end
  end
  file.delete()
end

list_adapter.onItemClick=function(adapter,itemView,view,pos)
  local check=view.getChildAt(0)
  check.setChecked(not check.checked)
end

task(1,function()
  for i=0,list_adapter.itemCount-1
    recycler.getChildAt(i).getChildAt(0).setOnCheckedChangeListener{
      onCheckedChanged=function(view,checked)
        local size=0
        for i=0,list_adapter.itemCount-1
          local check=recycler.getChildAt(i).getChildAt(0)
          if check.checked
            local current=GetDirSize(CacheData[i+1].dir)
            size=size+current
            check.setText(CacheData[i+1].text.." ("..Formatter.formatFileSize(activity,current)..")")
          end
        end
        clear_bt.setText("确定清理".." ("..Formatter.formatFileSize(activity,size)..")")
      end}
  end
end)

clear_bt.onClick=function()
  for i=0,list_adapter.itemCount-1
    local check=recycler.getChildAt(i).getChildAt(0)
    if check.checked
      DeleteDir(CacheData[i+1].dir)
      check.setChecked(false)
    end
  end
  UpdateCacheList()
  clear_bt.setText("确定清理 (0 B)")
end
