--[[
 @author jiecs
 @description jies辰 关于页示例
 鸣谢列表超过五张图片会导致滚动卡顿
]]

-- ****导入****
require "import"
import "android.os.*"
import "android.widget.*"
import "android.view.*"

--uiManager
uiManager=activity.getUiManager()

--配色
import "android.graphics.Color"
local colors=uiManager.getColors()
colorPrimary=Color.parseColor(colors.colorPrimary)
colorAccent=Color.parseColor(colors.colorAccent)
colorTextPrimary=Color.parseColor(colors.textColorPrimary)
colorTextSecondary=Color.parseColor(colors.textColorSecondary)
import "com.google.android.material.card.MaterialCardView"
import "androidx.core.graphics.ColorUtils"
import "android.content.res.ColorStateList"
import "com.google.android.material.imageview.ShapeableImageView"
import "androidx.recyclerview.widget.RecyclerView"
import "androidx.core.widget.NestedScrollView"
--加载layout
list=ArrayList()
list.add(loadlayout("layout"))
import "net.fusionapp.core.ui.adapter.BasePagerAdapter"
uiManager.viewPager.setAdapter(BasePagerAdapter(list))


local packageManager=activity.getPackageManager()
app_img.setImageDrawable(packageManager.getApplicationIcon(activity.getPackageName()))
local packinfo=packageManager.getPackageInfo(activity.getPackageName(),0)
local app_version_name=tostring(packinfo.versionName)
local app_version_code=tointeger(packinfo.versionCode)
app_ver_text.text=app_version_name..'('..app_version_code..')'


local tks_item_layout={MaterialCardView,
  layout_width="match",
  elevation=0,
  radius=0,
  cardBackgroundColor=colorPrimary,
  id="card",
  {RelativeLayout,
    padding="13dp",
    {FrameLayout,
      layout_width="50dp",
      layout_centerVertical="true",
      id="img_frame",
      {ProgressBar,
        layout_gravity="center",
        indeterminateTintList=ColorStateList.valueOf(colorAccent),
      },
      {ShapeableImageView,
        layout_width="50dp",
        adjustViewBounds=true,
        backgroundColor=0xffffffff,
        id="img",
        visibility=0,
      },
    },
    {TextView,
      layout_toRightOf="img_frame",
      layout_marginLeft="10dp",
      textSize="16sp",
      textColor=colorTextPrimary,
      id="title",
    },
    {TextView,
      layout_below="title",
      layout_alignLeft="title",
      textSize="15sp",
      textColor=colorTextSecondary,
      id="message",
    },
  },
}
local tks_data={
  {title="FusionApp",
    message="本应用由 FusionApp 2.0 64位 开发，致力于更优雅的移动编程",
    img=packageManager.getApplicationIcon(activity.getPackageName()),--"https://img-youpai.weixiaoi.com/tu/2022/0206/1644124676220206.png",
    url="https://www.coolapk.com/apk/cn.coldsong.fusionapp",
  },
  {title="ZeroWorld",
    message="软件作者，多个平台用户名不同 以QQ号为准。点击访问本软件开源地址",
    img="https://q.qlogo.cn/headimg_dl?dst_uin=2801901164&spec=640",
    url="https://www.118pan.com/o25197",
  },
}
--设置适配器
import "androidx.recyclerview.widget.LinearLayoutManager"
tks_recycler.layoutManager=LinearLayoutManager(activity)
local tks_adapter=LuaRecyclerAdapter(activity,tks_data,tks_item_layout)
tks_adapter.clickViewId="card"
tks_recycler.setAdapter(tks_adapter)

import "android.content.Intent"
import "android.net.Uri"
tks_adapter.onItemClick=function(adapter,itemView,view,pos)
  local url=tks_data[pos+1].url
  if url then activity.startActivity(Intent("android.intent.action.VIEW",Uri.parse(url))) end
end
