-- @author 寒歌
-- @description Main是应用的主模块，其中注册了应用运行中UI事件的回调、Activity生命周期的回调等
-- 你也可以在此编写启动事件代码，或控制应用运行逻辑、自定义应用UI等等。
-- @other 本模版已为你编写好基础事件，建议在阅读注释并理解相关参数意义后再进行扩展编写
-- 特别注意：本初始化模板为自定义视图演示模板，未提供其它功能使用示例，如需了解其它内置UI组件使用示例，请创建其它对应模板
--
require"import"
import "com.google.android.material.card.MaterialCardView"
import "android.widget.*"
import "com.google.android.material.snackbar.Snackbar"
import "android.graphics.Color"
import "net.fusionapp.core.ui.adapter.BasePagerAdapter"
import "androidx.recyclerview.widget.*"
import "com.scwang.smartrefresh.layout.SmartRefreshLayout"
import "com.scwang.smartrefresh.header.DeliveryHeader"
import "com.scwang.smartrefresh.header.TaurusHeader"
import "com.scwang.smartrefresh.header.DropBoxHeader"
import "android.os.Bundle"
--导入layout布局
import "layout"

local uiManager=this.uiManager
local colors=uiManager.getColors()
colorPrimary=colors.colorPrimary--主色
colorAccent=colors.colorAccent--强调
colorTextPrimary=colors.textColorPrimary--主文本色
textColorSecondary=colors.textColorSecondary
colorBackground=colors.windowBackground--窗体背景色

if activity.getPackageName()=="net.fusionapp" then
  R=luajava.bindClass "net.fusionapp.R"
 else
  R=luajava.bindClass "net.fusionapp.core.R"
end
--UI管理器
UiManager=this.UiManager
local viewPager=UiManager.viewPager
--加载layout
local list=ArrayList()
list.add(loadlayout(layout))

viewPager.setAdapter(BasePagerAdapter(list))
function copy(text)
  activity.getSystemService("clipboard").text=text
  print("复制成功")
end
function onFloatingActionButtonClick(v)
  recycler_view.smoothScrollToPosition(0);
end
local function popup(v,k)
  import "android.content.res.ColorStateList"
  import "androidx.appcompat.widget.PopupMenu"
  local Color = luajava.bindClass "android.graphics.Color"
  local colorAccent1=Color.parseColor(this.UiManager.colors.colorAccent)
  local textColorPrimary1=Color.parseColor(this.UiManager.colors.textColorPrimary)
  local textColorSecondary1=Color.parseColor(this.UiManager.colors.textColorSecondary)
  local data=recycler_view.getAdapter().Data[k]
  local popupMenu=PopupMenu(activity,v)
  local menu=popupMenu.menu
  menu.add("违规人主页").setIcon(R.drawable.abc_ic_go_search_api_material).setIconTintList(ColorStateList.valueOf(colorAccent1))
  menu.add("处理人主页").setIcon(R.drawable.abc_ic_go_search_api_material).setIconTintList(ColorStateList.valueOf(colorAccent1))

  local subMenu1=menu.addSubMenu("复制文本")
  subMenu1.setHeaderTitle("复制文本...")
  subMenu1.add("复制违规人UID").setIcon(R.drawable.abc_ic_menu_overflow_material).setIconTintList(ColorStateList.valueOf(colorAccent1))
  subMenu1.add("复制处理人UID").setIcon(R.drawable.abc_ic_menu_overflow_material).setIconTintList(ColorStateList.valueOf(colorAccent1))
  if data.title ~= "" then
    subMenu1.add("复制违规原因").setIcon(R.drawable.abc_ic_menu_overflow_material).setIconTintList(ColorStateList.valueOf(colorAccent1))
  end
  subMenu1.item.setIcon(R.drawable.abc_ic_menu_overflow_material).setIconTintList(ColorStateList.valueOf(colorAccent1))

  menu.setOptionalIconsVisible(true)

  popupMenu.onMenuItemClick=function(item)
    switch item.title
     case "违规人主页"
      local id=data.uid
      local bundle=Bundle()
      bundle.putString("url","https://ysqbbs.com/home.php?mod=space&uid="..id.."&do=profile")
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
     case "处理人主页"
      local id=data.operatorid
      local bundle=Bundle()
      bundle.putString("url","https://ysqbbs.com/home.php?mod=space&uid="..id.."&do=profile")
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
     case "复制违规人UID"
      copy(data.uid)
     case "复制处理人UID"
      copy(data.operatorid)
     case "复制违规原因"
      copy(data.title)
    end
  end
  popupMenu.show()
end
--设置列表布局
local list_item={
  LinearLayout,
  layout_width="match",
  layout_height="wrap",
  {
    MaterialCardView,
    id="card",
    layout_margin="10dp",
    layout_marginLeft='20dp';--布局左距
    layout_marginRight='20dp';--布局右距
    layout_width="match",
    layout_height="wrap",
    cardBackgroundColor=colorPrimary,--卡片背景色
    cardElevation="0dp",--卡片阴影强度
    radius="12dp",--卡片圆角幅度
    {
      LinearLayout,
      layout_width="match",
      layout_height="wrap",
      padding="13dp",
      Orientation=1,
      {
        LinearLayout,
        layout_width="match",
        layout_height="wrap",
        Orientation=2,
        layout_marginTop='2.5dp';--布局顶距
        gravity='left|center';--控件内容的重力方向
        {
          CircleImageView;--圆图控件
          layout_width='40dp';--控件宽度
          layout_height='40dp';--控件高度
          -- layout_margin='10dp';--控件外边距
          id='Image_Avatar';--设置控件ID
          layout_gravity='center';--重力
        };
        {
          LinearLayout,
          layout_width="wrap",
          layout_marginLeft='10dp';--布局左距
          layout_height="wrap",
          Orientation=1,
          {
            TextView,
            id="Name",
            textSize="15sp",
            textStyle="bold",
            textColor=textColorPrimary,
            singleLine=true;--设置单行输入
            ellipsize='end';--多余文字用省略号显示
          },
          {
            TextView,
            id="Tag",
            layout_marginTop='4dp';--布局顶距
            textSize="12sp",
            textColor=textColorSecondary,
          },
        },
      },
      {
        LinearLayout,
        layout_width="match",
        layout_height="wrap",
        layout_marginTop='10dp';--布局顶距
        -- padding="24dp",
        Orientation=1,
        {
          LinearLayout,
          layout_width="wrap",
          layout_height="wrap",
          Orientation=2,
          gravity='center';--重力
          {
            MaterialCardView,
            id="cardview",--设置ID
            layout_height="18dp",
            layout_width="wrap",
            strokeWidth="1dp", --边框宽度
            strokeColor="#ff0000", --边框颜色
            layout_marginRight='5dp';--布局右距
            cardBackgroundColor=colorPrimary,--卡片背景色
            cardElevation="0dp",--卡片阴影强度
            radius="2dp",--卡片圆角幅度
            {
              TextView,
              id="Small_label",
              textSize="12sp",
              layout_height="18dp",
              layout_width="wrap",
              --text="红包贴",
              layout_margin='2dp';
              layout_gravity='center';--重力
              textColor="#ff0000",
            },
          },
          {
            MaterialCardView,
            id="cardview2",--设置ID
            layout_height="18dp",
            layout_width="wrap",
            strokeWidth="1dp", --边框宽度
            strokeColor="#FFFF5D46", --边框颜色
            layout_marginRight='5dp';--布局右距
            cardBackgroundColor=colorPrimary,--卡片背景色
            cardElevation="0dp",--卡片阴影强度
            radius="2dp",--卡片圆角幅度
            {
              TextView,
              id="Small_label2",
              textSize="12sp",
              layout_height="18dp",
              layout_width="wrap",
              --text="红包贴",
              layout_margin='2dp';
              layout_gravity='center';--重力
              textColor="#FFFF5D46",
            },
          },
        },

        {
          MaterialCardView,
          id="card2",
          layout_marginTop="10dp",
          layout_width="match",
          layout_height="wrap",
          cardBackgroundColor="#33bbbbbb",--卡片背景色
          cardElevation="0dp",--卡片阴影强度
          radius="12dp",--卡片圆角幅度
          {
            LinearLayout,
            layout_width="match",
            layout_height="wrap",
            padding="13dp",
            Orientation=1,
            {
              LinearLayout,
              layout_width="match",
              layout_height="wrap",

              Orientation=2,
              layout_marginTop='2.5dp';--布局顶距
              gravity='left|center';--控件内容的重力方向
              {
                CircleImageView;--圆图控件
                layout_width='30dp';--控件宽度
                layout_height='30dp';--控件高度
                -- layout_margin='10dp';--控件外边距
                id='Image_Avatar2';--设置控件ID
                layout_gravity='center';--重力
              };
              {
                TextView,
                id="Name2",
                layout_marginLeft='10dp';--布局左距
                textSize="15sp",
                textStyle="bold",
                textColor=textColorPrimary,
                singleLine=true;--设置单行输入
                ellipsize='end';--多余文字用省略号显示
              },
            },
            {
              TextView,
              id="title",
              layout_marginTop='10dp';--布局顶距
              textSize="16sp",
              textStyle="bold",
              textColor=textColorPrimary,
            },
          },
        },
      },
    },
  },
}



--设置线性列表布局
recycler_view.layoutManager=LinearLayoutManager(activity)

local adapter=LuaRecyclerAdapter(activity,{},list_item)


--设置点击事件控件id,如果没有，则默认给列表项目父布局设置事件
--这里因为要给卡片控件设置事件，所以指定id为"card"
adapter.clickViewId="card"

adapter.setAdapterInterface(LuaRecyclerAdapter.AdapterInterface{
  onBindViewHolder=function(viewHolder,index)
    --获取控件并操作
    viewHolder.tag.card.onClick=function()
      popup(viewHolder.tag.Small_label2,index+1)
    end
    switch(viewHolder.tag.title.text)
     case ""
      viewHolder.tag.title.setVisibility(this.uiManager.viewPager.GONE)
    end
    --[[  if recycler_view.adapter.getItemCount() == (index + 1) then
    --  print(1)
      Initialization()
    end]]
  end
})
--设置适配器
recycler_view.adapter=adapter
function Snack(t)
  import "com.google.android.material.snackbar.Snackbar"
  local parent=UiManager.coordinatorLayout
  local duration=Snackbar.LENGTH_SHORT
  Snackbar.make(parent,t, duration)
  .setActionTextColor(Color.parseColor(UiManager.getColors().getColorAccent()))
  .setAction("确定",{onClick=function()

    end})
  .show()
end
local function html转义(content)
  local content=content:gsub("amp;","") or content;
  local content=content:gsub("&nbsp;"," ") or content;
  local content=content:gsub("&lt;","<") or content;
  local content=content:gsub("&gt;",">") or content;
  local content=content:gsub("&amp;","&") or content;
  local content=content:gsub("&quot;",'"') or content;
  local content=content:gsub("&#39;","'") or content;
  local content=content:gsub("&#47","/") or content;
  local content=content:gsub("#x27","\\") or content;
  local content=content:gsub("&#x60","`") or content;
  local content=content:gsub("&copy","©") or content;
  return content
end

function Initialization(v)
  if v==1 then
    cid2=""
    adapter.clear()
   else
    cid2="&cid="..cid
  end
  local url="https://ysqbbs.com/forum.php?mod=misc&action=showdarkroom"..cid2.."&ajaxdata=json&t="..math.random(10000000,17999999).."&ajaxdata=json"
  Http.get(url,nil,"UTF-8",function(code,body,cookie,header)
    if code==200 then
      -- print(body)
      
      local i, ci = body:match("message\":\"(.+)|(.-)\"")
      if i == "1" then
        cid = ci
      end

      local body=body:match('"data":{(.+)}')
      if body then
        local body=body:gmatch("[0-9]*[1-9][0-9]*:{(.-)}")

        for v in body do -- 正则匹配循环获取指定内容
          local v="{"..v.."}"
          local cjson=require("cjson")
          local json=cjson.decode(v)
          --print(json.username)
          -- cid=json.cid
          adapter.add({
            Image_Avatar="https://ysqbbs.com/uc_server/avatar.php?uid="..json.uid.."&size=middle",
            Name=json.username,Tag=html转义(json.dateline),title=json.reason,
            Small_label=json.action,Small_label2="到期："..html转义(json.groupexpiry),
            Image_Avatar2="https://ysqbbs.com/uc_server/avatar.php?uid="..json.operatorid.."&size=middle",
            Name2=json.operator,uid=json.uid,operatorid=json.operatorid,
          })
        end
        TestLayout.finishRefresh()
        TestLayout.finishLoadMore()
       else
        -- cid=cid-1
        Initialization()
      end
     else
      TestLayout.finishRefresh()
      TestLayout.finishLoadMore()
      print("失败："..code)
    end
  end)
end

TestLayout.autoRefresh();--这个就是刷新一下。直接调整会刷新。
TestLayout.setEnableAutoLoadMore(true);--是否启用列表惯性滑动到底部时自动加载更多
TestLayout.setEnableLoadMoreWhenContentNotFull(true);--是否在列表不满一页时候开启上拉加载功能

TestLayout.setPrimaryColors({Color.parseColor(colorAccent),Color.parseColor(colorPrimary)});--他的颜色。

TestLayout.setEnableLoadMore(true);--上拉加载。

TestLayout.onRefresh=function(v)--刷新时加载事件。
  Initialization(1)
end
TestLayout.onLoadMore=function(v)--加载时加载事件。
  --print(123)
  Initialization()
end


