--[[**
 * @Name: Permission.lua
 * @Date: 2021-05-23 12:51:03
 * @Description: No special instructions
 *
**]]


local base={

}

local t={}
setmetatable(t,t)

function apply(n)
  return function(f)
    t.__newindex=function(self,key,value)
      n[key]=value
      rawset(self,key,nil)
    end
    t.__index=function(self,key)
      return n[key] or _ENV[key]
    end
    f(t)
  end
end



apply(base)(function(_ENV)
  ACCEPT_HANDOVER = "android.permission.ACCEPT_HANDOVER";
  ACCESS_BACKGROUND_LOCATION = "android.permission.ACCESS_BACKGROUND_LOCATION";
  ACCESS_COARSE_LOCATION = "android.permission.ACCESS_COARSE_LOCATION";
  ACCESS_FINE_LOCATION = "android.permission.ACCESS_FINE_LOCATION";
  ACCESS_MEDIA_LOCATION = "android.permission.ACCESS_MEDIA_LOCATION";
  ACTIVITY_RECOGNITION = "android.permission.ACTIVITY_RECOGNITION";
  ADD_VOICEMAIL = "com.android.voicemail.permission.ADD_VOICEMAIL";
  ANSWER_PHONE_CALLS = "android.permission.ANSWER_PHONE_CALLS";
  BODY_SENSORS = "android.permission.BODY_SENSORS";
  CALL_PHONE = "android.permission.CALL_PHONE";
  CAMERA = "android.permission.CAMERA";
  GET_ACCOUNTS = "android.permission.GET_ACCOUNTS";
  MANAGE_EXTERNAL_STORAGE = "android.permission.MANAGE_EXTERNAL_STORAGE";
  NOTIFICATION_SERVICE = "android.permission.NOTIFICATION_SERVICE";
  PROCESS_OUTGOING_CALLS = "android.permission.PROCESS_OUTGOING_CALLS";
  READ_CALENDAR = "android.permission.READ_CALENDAR";
  READ_CALL_LOG = "android.permission.READ_CALL_LOG";
  READ_CONTACTS = "android.permission.READ_CONTACTS";
  READ_EXTERNAL_STORAGE = "android.permission.READ_EXTERNAL_STORAGE";
  READ_PHONE_NUMBERS = "android.permission.READ_PHONE_NUMBERS";
  READ_PHONE_STATE = "android.permission.READ_PHONE_STATE";
  READ_SMS = "android.permission.READ_SMS";
  RECEIVE_MMS = "android.permission.RECEIVE_MMS";
  RECEIVE_SMS = "android.permission.RECEIVE_SMS";
  RECEIVE_WAP_PUSH = "android.permission.RECEIVE_WAP_PUSH";
  RECORD_AUDIO = "android.permission.RECORD_AUDIO";
  REQUEST_INSTALL_PACKAGES = "android.permission.REQUEST_INSTALL_PACKAGES";
  SEND_SMS = "android.permission.SEND_SMS";
  SYSTEM_ALERT_WINDOW = "android.permission.SYSTEM_ALERT_WINDOW";
  USE_SIP = "android.permission.USE_SIP";
  WRITE_CALENDAR = "android.permission.WRITE_CALENDAR";
  WRITE_CALL_LOG = "android.permission.WRITE_CALL_LOG";
  WRITE_CONTACTS = "android.permission.WRITE_CONTACTS";
  WRITE_EXTERNAL_STORAGE = "android.permission.WRITE_EXTERNAL_STORAGE";
  WRITE_SETTINGS = "android.permission.WRITE_SETTINGS";

end)




base.Group={}
apply(base.Group)(function(_ENV)
  CALENDAR = {"android.permission.READ_CALENDAR", "android.permission.WRITE_CALENDAR"};
  CONTACTS = {"android.permission.READ_CONTACTS", "android.permission.WRITE_CONTACTS", "android.permission.GET_ACCOUNTS"};
  SENSORS = {"android.permission.BODY_SENSORS", "android.permission.ACTIVITY_RECOGNITION"};
  STORAGE = {"android.permission.READ_EXTERNAL_STORAGE", "android.permission.WRITE_EXTERNAL_STORAGE"};
end)

return base