--[[**
 * @Name: XXPermissions.lua
 * @Date: 2021-05-22 08:52:00
 * @Description: No special instructions
 *
**]]


--小白权限申请模块 快速申请权限


local PackageManager = luajava.bindClass "android.content.pm.PackageManager"

local base={}


base.with=function(self)
  local new=table.clone(self)
  new.permissions={}
  return new
end

base.permissionGroup=function(self,...)
  local all={...}
  for i=1,#all do
    self:permission(all[i])
  end
  return self
end

base.permission=function(self,...)
  if type(select(1,...))=="table" then
    self:permission(table.unpack(select(1,...)))
   else
    local all={...}
    for i=1,#all do
      table.insert(self.permissions,all[i])
    end
  end
  return self
end

base.getAllPermissionList=function(t)
  local pm = activity.getPackageManager();
  local pi = pm.getPackageInfo(activity.getPackageName(), 0);
  -- 得到自己的包名
  local pkgName = pi.packageName;
  local pkgInfo = pm.getPackageInfo(pkgName,
  PackageManager.GET_PERMISSIONS); --通过包名，返回包信息
  local sharedPkgList = t or luajava.astable(pkgInfo.requestedPermissions); --得到权限列表

  local permission_info = {}
  for i = 1, #sharedPkgList do
    if activity.checkCallingOrSelfPermission(sharedPkgList[i])==-1 then
      table.insert(permission_info,sharedPkgList[i])
    end
  end
  return permission_info
end

base.allPermission=function(self)
  local list=self.getAllPermissionList()
  if #list>0 then
    self:permission(list)
  end
  return self
end

base.start=function(self)
  self.permissions=self.getAllPermissionList(self.permissions)
  if #self.permissions==0 then
    task(20,lambda _:pcall(self.callbackt,true,{},{}))
    return self
  end
  activity.requestPermissions(self.permissions,10000)
  function onRequestPermissionsResult(reCode,permissions,grantResults)
    local successPermissionList={}
    local failPermissionList={}
    for i=0,#permissions-1 do
      if grantResults[i] == PackageManager.PERMISSION_GRANTED then
        table.insert(successPermissionList,permissions[i])
       else
        table.insert(failPermissionList,permissions[i])
      end
    end

    pcall(self.callbackt,#failPermissionList==0,successPermissionList,failPermissionList)
  end

  return self
end

base.callback=function(self,callback)
  self.callbackt=callback
end

base.checkPermission=function(...)
  if type(select(1,...))=="table" then
    return base.checkPermission(table.unpack(select(1,...)))
   elseif select("#",...)==1 then
    return activity.checkCallingOrSelfPermission(select(1,...))==0
   else
    local result={}
    local data={...}
    for i=1,#data do
      local s=activity.checkCallingOrSelfPermission(data[i])
      if s~=0 then
        table.insert(result,data[i])
      end
    end
    return result
  end

end


base.Permission=import "SimplePermissions.Permission"


base.开始=base.with
base.请求权限=base.permission
base.请求全部权限=base.allPermission
base.启动=base.start
base.回调=base.callback
base.检查权限=base.checkPermission
base.权限组=base.permissionGroup
base.权限=base.Permission
权限请求框架=base

return base